import{S as Or,i as Gr,s as Lr,e as r,k as u,w as d,t as o,M as Mr,c as l,d as t,m as h,a as p,x as g,h as n,b as m,N as na,G as a,g as i,y as v,q as w,o as y,B as b,v as Wr}from"../../chunks/vendor-hf-doc-builder.js";import{T as Br}from"../../chunks/Tip-hf-doc-builder.js";import{I as Te}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ft}from"../../chunks/CodeBlock-hf-doc-builder.js";function Rr(qe){let f;return{c(){f=o(`\u{1F4A1} In practice, people use the term FFT interchangeably with DFT, as the FFT or Fast Fourier Transform is the only efficient
way to calculate the DFT on a computer.`)},l(c){f=n(c,`\u{1F4A1} In practice, people use the term FFT interchangeably with DFT, as the FFT or Fast Fourier Transform is the only efficient
way to calculate the DFT on a computer.`)},m(c,_){i(c,f,_)},d(c){c&&t(f)}}}function Yr(qe){let f;return{c(){f=o(`\u{1F4A1} Not all mel spectrograms are the same! There are two different mel scales in common use ("htk" and "slaney"),
and instead of the power spectrogram the amplitude spectrogram may be used. The conversion to a log-mel spectrogram doesn't
always compute true decibels but may simply take the \`log\`. Therefore, if a machine learning model expects a mel spectrogram
as input, double check to make sure you're computing it the same way.`)},l(c){f=n(c,`\u{1F4A1} Not all mel spectrograms are the same! There are two different mel scales in common use ("htk" and "slaney"),
and instead of the power spectrogram the amplitude spectrogram may be used. The conversion to a log-mel spectrogram doesn't
always compute true decibels but may simply take the \`log\`. Therefore, if a machine learning model expects a mel spectrogram
as input, double check to make sure you're computing it the same way.`)},m(c,_){i(c,f,_)},d(c){c&&t(f)}}}function Jr(qe){let f,c,_,j,ct,le,Cs,dt,js,ra,Ee,Ns,la,k,Bs,gt,Os,Gs,vt,Ls,Ms,wt,Ws,Rs,pa,$e,Ys,ua,A,N,yt,pe,Js,bt,Us,ha,B,Vs,_t,Ks,Qs,ma,O,xe,on,Xs,Se,Zs,ue,ei,fa,G,ti,kt,ai,si,ca,ze,ii,da,$,oi,Tt,ni,ri,Pe,li,pi,ga,F,L,qt,he,ui,Et,hi,va,Ae,mi,wa,M,fi,$t,ci,di,ya,W,gi,xt,vi,wi,ba,Fe,yi,_a,R,bi,He,_i,ki,ka,Ie,Ti,Ta,H,Y,St,me,qi,zt,Ei,qa,x,$i,Pt,xi,Si,At,zi,Pi,Ea,De,Ai,$a,J,Fi,Ft,Hi,Ii,xa,fe,Sa,Ce,Di,za,ce,Pa,T,Ci,Ht,ji,Ni,It,Bi,Oi,Dt,Gi,Li,Aa,de,Fa,je,Ne,nn,Ha,Be,Mi,Ia,Oe,Wi,Da,I,U,Ct,ge,Ri,jt,Yi,Ca,S,Ji,Nt,Ui,Vi,Bt,Ki,Qi,ja,V,Xi,Ot,Zi,eo,Na,ve,Ba,Ge,Le,rn,Oa,Me,to,Ga,We,ao,La,K,so,Gt,io,oo,Ma,z,no,Lt,ro,lo,Mt,po,uo,Wa,Q,Ra,Re,ho,Ya,D,X,Wt,we,mo,Rt,fo,Ja,Z,co,Yt,go,vo,Ua,Ye,wo,Va,Je,yo,Ka,P,bo,Jt,_o,ko,Ut,To,qo,Qa,ye,Xa,Ue,Ve,ln,Za,Ke,Eo,es,ee,$o,Vt,xo,So,ts,Qe,zo,as,Xe,Po,ss,Ze,Ao,is,C,te,Kt,be,Fo,Qt,Ho,os,et,Io,ns,tt,Do,rs,at,Co,ls,ae,jo,Xt,No,Bo,ps,_e,us,st,it,pn,hs,q,Oo,Zt,Go,Lo,ea,Mo,Wo,ta,Ro,Yo,ms,E,Jo,aa,Uo,Vo,sa,Ko,Qo,ia,Xo,Zo,fs,se,cs,ot,en,ds,nt,tn,gs,rt,an,vs;return le=new Te({}),pe=new Te({}),he=new Te({}),me=new Te({}),fe=new ft({props:{code:"pip install librosa",highlighted:"pip install librosa"}}),ce=new ft({props:{code:`import librosa

array, sampling_rate = librosa.load(librosa.ex("trumpet"))`,highlighted:`<span class="hljs-keyword">import</span> librosa

array, sampling_rate = librosa.load(librosa.ex(<span class="hljs-string">&quot;trumpet&quot;</span>))`}}),de=new ft({props:{code:`import matplotlib.pyplot as plt
import librosa.display

plt.figure().set_figwidth(12)
librosa.display.waveshow(array, sr=sampling_rate)`,highlighted:`<span class="hljs-keyword">import</span> matplotlib.pyplot <span class="hljs-keyword">as</span> plt
<span class="hljs-keyword">import</span> librosa.display

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
librosa.display.waveshow(array, sr=sampling_rate)`}}),ge=new Te({}),ve=new ft({props:{code:`import numpy as np

dft_input = array[:4096]

# calculate the DFT
window = np.hanning(len(dft_input))
windowed_input = dft_input * window
dft = np.fft.rfft(windowed_input)

# get the amplitude spectrum in decibels
amplitude = np.abs(dft)
amplitude_db = librosa.amplitude_to_db(amplitude, ref=np.max)

# get the frequency bins
frequency = librosa.fft_frequencies(sr=sampling_rate, n_fft=len(dft_input))

plt.figure().set_figwidth(12)
plt.plot(frequency, amplitude_db)
plt.xlabel("Frequency (Hz)")
plt.ylabel("Amplitude (dB)")
plt.xscale("log")`,highlighted:`<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

dft_input = array[:<span class="hljs-number">4096</span>]

<span class="hljs-comment"># calculate the DFT</span>
window = np.hanning(<span class="hljs-built_in">len</span>(dft_input))
windowed_input = dft_input * window
dft = np.fft.rfft(windowed_input)

<span class="hljs-comment"># get the amplitude spectrum in decibels</span>
amplitude = np.<span class="hljs-built_in">abs</span>(dft)
amplitude_db = librosa.amplitude_to_db(amplitude, ref=np.<span class="hljs-built_in">max</span>)

<span class="hljs-comment"># get the frequency bins</span>
frequency = librosa.fft_frequencies(sr=sampling_rate, n_fft=<span class="hljs-built_in">len</span>(dft_input))

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
plt.plot(frequency, amplitude_db)
plt.xlabel(<span class="hljs-string">&quot;Frequency (Hz)&quot;</span>)
plt.ylabel(<span class="hljs-string">&quot;Amplitude (dB)&quot;</span>)
plt.xscale(<span class="hljs-string">&quot;log&quot;</span>)`}}),Q=new Br({props:{$$slots:{default:[Rr]},$$scope:{ctx:qe}}}),we=new Te({}),ye=new ft({props:{code:`import numpy as np

D = librosa.stft(array)
S_db = librosa.amplitude_to_db(np.abs(D), ref=np.max)

plt.figure().set_figwidth(12)
librosa.display.specshow(S_db, x_axis="time", y_axis="hz")
plt.colorbar()`,highlighted:`<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

D = librosa.stft(array)
S_db = librosa.amplitude_to_db(np.<span class="hljs-built_in">abs</span>(D), ref=np.<span class="hljs-built_in">max</span>)

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
librosa.display.specshow(S_db, x_axis=<span class="hljs-string">&quot;time&quot;</span>, y_axis=<span class="hljs-string">&quot;hz&quot;</span>)
plt.colorbar()`}}),be=new Te({}),_e=new ft({props:{code:`S = librosa.feature.melspectrogram(y=array, sr=sampling_rate, n_mels=128, fmax=8000)
S_dB = librosa.power_to_db(S, ref=np.max)

plt.figure().set_figwidth(12)
librosa.display.specshow(S_dB, x_axis="time", y_axis="mel", sr=sampling_rate, fmax=8000)
plt.colorbar()`,highlighted:`S = librosa.feature.melspectrogram(y=array, sr=sampling_rate, n_mels=<span class="hljs-number">128</span>, fmax=<span class="hljs-number">8000</span>)
S_dB = librosa.power_to_db(S, ref=np.<span class="hljs-built_in">max</span>)

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
librosa.display.specshow(S_dB, x_axis=<span class="hljs-string">&quot;time&quot;</span>, y_axis=<span class="hljs-string">&quot;mel&quot;</span>, sr=sampling_rate, fmax=<span class="hljs-number">8000</span>)
plt.colorbar()`}}),se=new Br({props:{$$slots:{default:[Yr]},$$scope:{ctx:qe}}}),{c(){f=r("meta"),c=u(),_=r("h1"),j=r("a"),ct=r("span"),d(le.$$.fragment),Cs=u(),dt=r("span"),js=o("Introduction to audio data"),ra=u(),Ee=r("p"),Ns=o(`By nature, a sound wave is a continuous signal, meaning it contains an infinite number of signal values in a given time.
This poses problems for digital devices which expect finite arrays. To be processed, stored, and transmitted by digital
devices, the continuous sound wave needs to be converted into a series of discrete values, known as a digital representation.`),la=u(),k=r("p"),Bs=o(`If you look at any audio dataset, you\u2019ll find digital files with sound excerpts, such as text narration or music.
You may encounter different file formats such as `),gt=r("code"),Os=o(".wav"),Gs=o(" (Waveform Audio File), "),vt=r("code"),Ls=o(".flac"),Ms=o(` (Free Lossless Audio Codec)
and `),wt=r("code"),Ws=o(".mp3"),Rs=o(" (MPEG-1 Audio Layer 3). These formats mainly differ in how they compress the digital representation of the audio signal."),pa=u(),$e=r("p"),Ys=o(`Let\u2019s take a look at how we arrive from a continuous signal to this representation. The analog signal is first captured by
a microphone, which converts the sound waves into an electrical signal. The electrical signal is then digitized by an
Analog-to-Digital Converter to get the digital representation through sampling.`),ua=u(),A=r("h2"),N=r("a"),yt=r("span"),d(pe.$$.fragment),Js=u(),bt=r("span"),Us=o("Sampling and sampling rate"),ha=u(),B=r("p"),Vs=o("Sampling is the process of measuring the value of a continuous signal at fixed time steps. The sampled waveform is "),_t=r("em"),Ks=o("discrete"),Qs=o(`,
since it contains a finite number of signal values at uniform intervals.`),ma=u(),O=r("p"),xe=r("img"),Xs=u(),Se=r("em"),Zs=o("Illustration from Wikipedia article: "),ue=r("a"),ei=o("Sampling (signal processing)"),fa=u(),G=r("p"),ti=o("The "),kt=r("strong"),ai=o("sampling rate"),si=o(` (also called sampling frequency) is the number of samples taken in one second and is measured in
hertz (Hz). To give you a point of reference, CD-quality audio has a sampling rate of 44,100 Hz, meaning samples are taken
44,100 times per second. For comparison, high-resolution audio has a sampling rate of 192,000 Hz or 192 kHz. A common
sampling rate used in training speech models is 16,000 Hz or 16 kHz.`),ca=u(),ze=r("p"),ii=o(`The choice of sampling rate primarily determines the highest frequency that can be captured from the signal. This is also
known as the Nyquist limit and is exactly half the sampling rate. The audible frequencies in human speech are below 8 kHz
and therefore sampling speech at 16 kHz is sufficient. Using a higher sampling rate will not capture more information and
merely leads to an increase in the computational cost of processing such files. On the other hand, sampling audio at too
low a sampling rate will result in information loss. Speech sampled at 8 kHz will sound muffled, as the higher frequencies
cannot be captured at this rate.`),da=u(),$=r("p"),oi=o(`It\u2019s important to ensure that all audio examples in your dataset have the same sampling rate when working on any audio task.
If you plan to use custom audio data to fine-tune a pre-trained model, the sampling rate of your data should match the
sampling rate of the data the model was pre-trained on. The sampling rate determines the time interval between successive
audio samples, which impacts the temporal resolution of the audio data. Consider an example: a 5-second sound at a sampling
rate of 16,000 Hz will be represented as a series of 80,000 values, while the same 5-second sound at a sampling rate of
8,000 Hz will be represented as a series of 40,000 values. Transformer models that solve audio tasks treat examples as
sequences and rely on attention mechanisms to learn audio or multimodal representation. Since sequences are different for
audio examples at different sampling rates, it will be challenging for models to generalize between sampling rates.
`),Tt=r("strong"),ni=o("Resampling"),ri=o(" is the process of making the sampling rates match, and is part of "),Pe=r("a"),li=o("preprocessing"),pi=o(" the audio data."),ga=u(),F=r("h2"),L=r("a"),qt=r("span"),d(he.$$.fragment),ui=u(),Et=r("span"),hi=o("Amplitude and bit depth"),va=u(),Ae=r("p"),mi=o("While the sampling rate tells you how often the samples are taken, what exactly are the values in each sample?"),wa=u(),M=r("p"),fi=o("Sound is made by changes in air pressure at frequencies that are audible to humans. The "),$t=r("strong"),ci=o("amplitude"),di=o(` of a sound describes
the sound pressure level at any given instant and is measured in decibels (dB). We perceive the amplitude as loudness.
To give you an example, a normal speaking voice is under 60 dB, and a rock concert can be at around 125 dB, pushing the
limits of human hearing.`),ya=u(),W=r("p"),gi=o("In digital audio, each audio sample records the amplitude of the audio wave at a point in time. The "),xt=r("strong"),vi=o("bit depth"),wi=o(` of the
sample determines with how much precision this amplitude value can be described. The higher the bit depth, the more
faithfully the digital representation approximates the original continuous sound wave.`),ba=u(),Fe=r("p"),yi=o(`The most common audio bit depths are 16-bit and 24-bit. Each is a binary term, representing the number of possible steps
to which the amplitude value can be quantized when it\u2019s converted from continuous to discrete: 65,536 steps for 16-bit audio,
a whopping 16,777,216 steps for 24-bit audio. Because quantizing involves rounding off the continuous value to a discrete
value, the sampling process introduces noise. The higher the bit depth, the smaller this quantization noise. In practice,
the quantization noise of 16-bit audio is already small enough to be inaudible, and using higher bit depths is generally
not necessary.`),_a=u(),R=r("p"),bi=o(`You may also come across 32-bit audio. This stores the samples as floating-point values, whereas 16-bit and 24-bit audio
use integer samples. The precision of a 32-bit floating-point value is 24 bits, giving it the same bit depth as 24-bit audio.
Floating-point audio samples are expected to lie within the [-1.0, 1.0] range. Since machine learning models naturally
work on floating-point data, the audio must first be converted into floating-point format before it can be used to train
the model. We\u2019ll see how to do this in the next section on `),He=r("a"),_i=o("Preprocessing"),ki=o("."),ka=u(),Ie=r("p"),Ti=o(`Just as with continuous audio signals, the amplitude of digital audio is typically expressed in decibels (dB). Since
human hearing is logarithmic in nature \u2014 our ears are more sensitive to small fluctuations in quiet sounds than in loud
sounds \u2014 the loudness of a sound is easier to interpret if the amplitudes are in decibels, which are also logarithmic.
The decibel scale for real-world audio starts at 0 dB, which represents the quietest possible sound humans can hear, and
louder sounds have larger values. However, for digital audio signals, 0 dB is the loudest possible amplitude, while all
other amplitudes are negative. As a quick rule of thumb: every -6 dB is a halving of the amplitude, and anything below -60 dB
is generally inaudible unless you really crank up the volume.`),Ta=u(),H=r("h2"),Y=r("a"),St=r("span"),d(me.$$.fragment),qi=u(),zt=r("span"),Ei=o("Audio as a waveform"),qa=u(),x=r("p"),$i=o("You may have seen sounds visualized as a "),Pt=r("strong"),xi=o("waveform"),Si=o(`, which plots the sample values over time and illustrates the changes
in the sound\u2019s amplitude. The is also known as the `),At=r("em"),zi=o("time domain"),Pi=o(" representation of sound."),Ea=u(),De=r("p"),Ai=o(`This type of visualization is useful for identifying specific features of the audio signal such as the timing of individual
sound events, the overall loudness of the signal, and any irregularities or noise present in the audio.`),$a=u(),J=r("p"),Fi=o("To plot the waveform for an audio signal, we can use a Python library called "),Ft=r("code"),Hi=o("librosa"),Ii=o(":"),xa=u(),d(fe.$$.fragment),Sa=u(),Ce=r("p"),Di=o("Let\u2019s take an example sound called \u201Ctrumpet\u201D that comes with the library:"),za=u(),d(ce.$$.fragment),Pa=u(),T=r("p"),Ci=o("The example is loaded as a tuple of audio time series (here we call it "),Ht=r("code"),ji=o("array"),Ni=o("), and sampling rate ("),It=r("code"),Bi=o("sampling_rate"),Oi=o(`).
Let\u2019s take a look at this sound\u2019s waveform by using librosa\u2019s `),Dt=r("code"),Gi=o("waveshow()"),Li=o(" function:"),Aa=u(),d(de.$$.fragment),Fa=u(),je=r("p"),Ne=r("img"),Ha=u(),Be=r("p"),Mi=o(`This plots the amplitude of the signal on the y-axis and time along the x-axis. In other words, each point corresponds
to a single sample value that was taken when this sound was sampled. Also note that librosa returns the audio as
floating-point values already, and that the amplitude values are indeed within the [-1.0, 1.0] range.`),Ia=u(),Oe=r("p"),Wi=o(`Visualizing the audio along with listening to it can be a useful tool for understanding the data you are working with.
You can see the shape of the signal, observe patterns, learn to spot noise or distortion. If you preprocess data in some
ways, such as normalization, resampling, or filtering, you can visually confirm that preprocessing steps have been applied as expected.
After training a model, you can also visualize samples where errors occur (e.g. in audio classification task) to debug
the issue.`),Da=u(),I=r("h2"),U=r("a"),Ct=r("span"),d(ge.$$.fragment),Ri=u(),jt=r("span"),Yi=o("The frequency spectrum"),Ca=u(),S=r("p"),Ji=o("Another way to visualize audio data is to plot the "),Nt=r("strong"),Ui=o("frequency spectrum"),Vi=o(" of an audio signal, also known as the "),Bt=r("em"),Ki=o("frequency domain"),Qi=o(`
representation. The spectrum is computed using the discrete Fourier transform or DFT. It describes the individual frequencies
that make up the signal and how strong they are.`),ja=u(),V=r("p"),Xi=o("Let\u2019s plot the frequency spectrum for the same trumpet sound by taking the DFT using numpy\u2019s "),Ot=r("code"),Zi=o("rfft()"),eo=o(` function. While it
is possible to plot the spectrum of the entire sound, it\u2019s more useful to look at a small region instead. Here we\u2019ll take
the DFT over the first 4096 samples, which is roughly the length of the first note being played:`),Na=u(),d(ve.$$.fragment),Ba=u(),Ge=r("p"),Le=r("img"),Oa=u(),Me=r("p"),to=o(`This plots the strength of the various frequency components that are present in this audio segment. The frequency values are on
the x-axis, usually plotted on a logarithmic scale, while their amplitudes are on the y-axis.`),Ga=u(),We=r("p"),ao=o(`The frequency spectrum that we plotted shows several peaks. These peaks correspond to the harmonics of the note that\u2019s
being played, with the higher harmonics being quieter. Since the first peak is at around 620 Hz, this is the frequency spectrum of an E\u266D note.`),La=u(),K=r("p"),so=o(`The output of the DFT is an array of complex numbers, made up of real and imaginary components. Taking
the magnitude with `),Gt=r("code"),io=o("np.abs(dft)"),oo=o(` extracts the amplitude information from the spectrogram. The angle between the real and
imaginary components provides the so-called phase spectrum, but this is often discarded in machine learning applications.`),Ma=u(),z=r("p"),no=o("You used "),Lt=r("code"),ro=o("librosa.amplitude_to_db()"),lo=o(` to convert the amplitude values to the decibel scale, making it easier to see
the finer details in the spectrum. Sometimes people use the `),Mt=r("strong"),po=o("power spectrum"),uo=o(`, which measures energy rather than amplitude;
this is simply a spectrum with the amplitude values squared.`),Wa=u(),d(Q.$$.fragment),Ra=u(),Re=r("p"),ho=o(`The frequency spectrum of an audio signal contains the exact same information as its waveform \u2014 they are simply two different
ways of looking at the same data (here, the first 4096 samples from the trumpet sound). Where the waveform plots the amplitude
of the audio signal over time, the spectrum visualizes the amplitudes of the individual frequencies at a fixed point in time.`),Ya=u(),D=r("h2"),X=r("a"),Wt=r("span"),d(we.$$.fragment),mo=u(),Rt=r("span"),fo=o("Spectrogram"),Ja=u(),Z=r("p"),co=o(`What if we want to see how the frequencies in an audio signal change? The trumpet plays several notes and they all have
different frequencies. The problem is that the spectrum only shows a frozen snapshot of the frequencies at a given instant.
The solution is to take multiple DFTs, each covering only a small slice of time, and stack the resulting spectra together
into a `),Yt=r("strong"),go=o("spectrogram"),vo=o("."),Ua=u(),Ye=r("p"),wo=o(`A spectrogram plots the frequency content of an audio signal as it changes over time. It allows you to see time, frequency,
and amplitude all on one graph. The algorithm that performs this computation is the STFT or Short Time Fourier Transform.`),Va=u(),Je=r("p"),yo=o(`The spectrogram is one of the most informative audio tools available to you. For example, when working with a music recording,
you can see the various instruments and vocal tracks and how they contribute to the overall sound. In speech, you can
identify different vowel sounds as each vowel is characterized by particular frequencies.`),Ka=u(),P=r("p"),bo=o("Let\u2019s plot a spectrogram for the same trumpet sound, using librosa\u2019s "),Jt=r("code"),_o=o("stft()"),ko=o(" and "),Ut=r("code"),To=o("specshow()"),qo=o(" functions:"),Qa=u(),d(ye.$$.fragment),Xa=u(),Ue=r("p"),Ve=r("img"),Za=u(),Ke=r("p"),Eo=o(`In this plot, the x-axis represents time as in the waveform visualization but now the y-axis represents frequency in Hz.
The intensity of the color gives the amplitude or power of the frequency component at each point in time, measured in decibels (dB).`),es=u(),ee=r("p"),$o=o(`The spectrogram is created by taking short segments of the audio signal, typically lasting a few milliseconds, and calculating
the discrete Fourier transform of each segment to obtain its frequency spectrum. The resulting spectra are then stacked
together on the time axis to create the spectrogram. Each vertical slice in this image corresponds to a single frequency
spectrum, seen from the top. By default, `),Vt=r("code"),xo=o("librosa.stft()"),So=o(` splits the audio signal into segments of 2048 samples, which
gives a good trade-off between frequency resolution and time resolution.`),ts=u(),Qe=r("p"),zo=o(`Since the spectrogram and the waveform are different views of the same data, it\u2019s possible to turn the spectrogram back
into the original waveform using the inverse STFT. However, this requires the phase information in addition to the amplitude
information. If the spectrogram was generated by a machine learning model, it typically only outputs the amplitudes. In
that case, we can use a phase reconstruction algorithm such as the classic Griffin-Lim algorithm, or using a neural network
called a vocoder, to reconstruct a waveform from the spectrogram.`),as=u(),Xe=r("p"),Po=o(`Spectrograms aren\u2019t just used for visualization. Many machine learning models will take spectrograms as input \u2014 as opposed
to waveforms \u2014 and produce spectrograms as output.`),ss=u(),Ze=r("p"),Ao=o("Now that we know what a spectrogram is and how it\u2019s made, let\u2019s take a look at a variant of it widely used for speech processing: the mel spectrogram."),is=u(),C=r("h2"),te=r("a"),Kt=r("span"),d(be.$$.fragment),Fo=u(),Qt=r("span"),Ho=o("Mel spectrogram"),os=u(),et=r("p"),Io=o(`A mel spectrogram is a variation of the spectrogram that is commonly used in speech processing and machine learning tasks.
It is similar to a spectrogram in that it shows the frequency content of an audio signal over time, but on a different frequency axis.`),ns=u(),tt=r("p"),Do=o(`In a standard spectrogram, the frequency axis is linear and is measured in hertz (Hz). However, the human auditory system
is more sensitive to changes in lower frequencies than higher frequencies, and this sensitivity decreases logarithmically
as frequency increases. The mel scale is a perceptual scale that approximates the non-linear frequency response of the human ear.`),rs=u(),at=r("p"),Co=o(`To create a mel spectrogram, the STFT is used just like before, splitting the audio into short segments to obtain a sequence
of frequency spectra. Additionally, each spectrum is sent through a set of filters, the so-called mel filterbank, to
transform the frequencies to the mel scale.`),ls=u(),ae=r("p"),jo=o("Let\u2019s see how we can plot a mel spectrogram using librosa\u2019s "),Xt=r("code"),No=o("melspectrogram()"),Bo=o(" function, which performs all of those steps for us:"),ps=u(),d(_e.$$.fragment),us=u(),st=r("p"),it=r("img"),hs=u(),q=r("p"),Oo=o("In the example above, "),Zt=r("code"),Go=o("n_mels"),Lo=o(` stands for the number of mel bands to generate. The mel bands define a set of frequency
ranges that divide the spectrum into perceptually meaningful components, using a set of filters whose shape and spacing
are chosen to mimic the way the human ear responds to different frequencies. Common values for `),ea=r("code"),Mo=o("n_mels"),Wo=o(" are 40 or 80. "),ta=r("code"),Ro=o("fmax"),Yo=o(`
indicates the highest frequency (in Hz) we care about.`),ms=u(),E=r("p"),Jo=o(`Just as with a regular spectrogram, it\u2019s common practice to express the strength of the mel frequency components in
decibels. This is commonly referred to as a `),aa=r("strong"),Uo=o("log-mel spectrogram"),Vo=o(`, because the conversion to decibels involves a
logarithmic operation. The above example used `),sa=r("code"),Ko=o("librosa.power_to_db()"),Qo=o(" as "),ia=r("code"),Xo=o("librosa.feature.melspectrogram()"),Zo=o(" creates a power spectrogram."),fs=u(),d(se.$$.fragment),cs=u(),ot=r("p"),en=o(`Creating a mel spectrogram is a lossy operation as it involves filtering the signal. Converting a mel spectrogram back
into a waveform is more difficult than doing this for a regular spectrogram, as it requires estimating the frequencies
that were thrown away. This is why machine learning models such as HiFiGAN vocoder are needed to produce a waveform from a mel
spectrogram.`),ds=u(),nt=r("p"),tn=o(`Compared to a standard spectrogram, a mel spectrogram can capture more meaningful features of the audio signal for
human perception, making it a popular choice in tasks such as speech recognition, speaker identification, and music genre classification.`),gs=u(),rt=r("p"),an=o("Now that you know how to visualize audio data examples, go ahead and try to see what your favorite sounds look like. :)"),this.h()},l(e){const s=Mr('[data-svelte="svelte-1phssyn"]',document.head);f=l(s,"META",{name:!0,content:!0}),s.forEach(t),c=h(e),_=l(e,"H1",{class:!0});var ke=p(_);j=l(ke,"A",{id:!0,class:!0,href:!0});var oa=p(j);ct=l(oa,"SPAN",{});var un=p(ct);g(le.$$.fragment,un),un.forEach(t),oa.forEach(t),Cs=h(ke),dt=l(ke,"SPAN",{});var hn=p(dt);js=n(hn,"Introduction to audio data"),hn.forEach(t),ke.forEach(t),ra=h(e),Ee=l(e,"P",{});var mn=p(Ee);Ns=n(mn,`By nature, a sound wave is a continuous signal, meaning it contains an infinite number of signal values in a given time.
This poses problems for digital devices which expect finite arrays. To be processed, stored, and transmitted by digital
devices, the continuous sound wave needs to be converted into a series of discrete values, known as a digital representation.`),mn.forEach(t),la=h(e),k=l(e,"P",{});var ie=p(k);Bs=n(ie,`If you look at any audio dataset, you\u2019ll find digital files with sound excerpts, such as text narration or music.
You may encounter different file formats such as `),gt=l(ie,"CODE",{});var fn=p(gt);Os=n(fn,".wav"),fn.forEach(t),Gs=n(ie," (Waveform Audio File), "),vt=l(ie,"CODE",{});var cn=p(vt);Ls=n(cn,".flac"),cn.forEach(t),Ms=n(ie,` (Free Lossless Audio Codec)
and `),wt=l(ie,"CODE",{});var dn=p(wt);Ws=n(dn,".mp3"),dn.forEach(t),Rs=n(ie," (MPEG-1 Audio Layer 3). These formats mainly differ in how they compress the digital representation of the audio signal."),ie.forEach(t),pa=h(e),$e=l(e,"P",{});var gn=p($e);Ys=n(gn,`Let\u2019s take a look at how we arrive from a continuous signal to this representation. The analog signal is first captured by
a microphone, which converts the sound waves into an electrical signal. The electrical signal is then digitized by an
Analog-to-Digital Converter to get the digital representation through sampling.`),gn.forEach(t),ua=h(e),A=l(e,"H2",{class:!0});var ws=p(A);N=l(ws,"A",{id:!0,class:!0,href:!0});var vn=p(N);yt=l(vn,"SPAN",{});var wn=p(yt);g(pe.$$.fragment,wn),wn.forEach(t),vn.forEach(t),Js=h(ws),bt=l(ws,"SPAN",{});var yn=p(bt);Us=n(yn,"Sampling and sampling rate"),yn.forEach(t),ws.forEach(t),ha=h(e),B=l(e,"P",{});var ys=p(B);Vs=n(ys,"Sampling is the process of measuring the value of a continuous signal at fixed time steps. The sampled waveform is "),_t=l(ys,"EM",{});var bn=p(_t);Ks=n(bn,"discrete"),bn.forEach(t),Qs=n(ys,`,
since it contains a finite number of signal values at uniform intervals.`),ys.forEach(t),ma=h(e),O=l(e,"P",{});var bs=p(O);xe=l(bs,"IMG",{src:!0,alt:!0}),Xs=h(bs),Se=l(bs,"EM",{});var sn=p(Se);Zs=n(sn,"Illustration from Wikipedia article: "),ue=l(sn,"A",{href:!0,rel:!0});var _n=p(ue);ei=n(_n,"Sampling (signal processing)"),_n.forEach(t),sn.forEach(t),bs.forEach(t),fa=h(e),G=l(e,"P",{});var _s=p(G);ti=n(_s,"The "),kt=l(_s,"STRONG",{});var kn=p(kt);ai=n(kn,"sampling rate"),kn.forEach(t),si=n(_s,` (also called sampling frequency) is the number of samples taken in one second and is measured in
hertz (Hz). To give you a point of reference, CD-quality audio has a sampling rate of 44,100 Hz, meaning samples are taken
44,100 times per second. For comparison, high-resolution audio has a sampling rate of 192,000 Hz or 192 kHz. A common
sampling rate used in training speech models is 16,000 Hz or 16 kHz.`),_s.forEach(t),ca=h(e),ze=l(e,"P",{});var Tn=p(ze);ii=n(Tn,`The choice of sampling rate primarily determines the highest frequency that can be captured from the signal. This is also
known as the Nyquist limit and is exactly half the sampling rate. The audible frequencies in human speech are below 8 kHz
and therefore sampling speech at 16 kHz is sufficient. Using a higher sampling rate will not capture more information and
merely leads to an increase in the computational cost of processing such files. On the other hand, sampling audio at too
low a sampling rate will result in information loss. Speech sampled at 8 kHz will sound muffled, as the higher frequencies
cannot be captured at this rate.`),Tn.forEach(t),da=h(e),$=l(e,"P",{});var lt=p($);oi=n(lt,`It\u2019s important to ensure that all audio examples in your dataset have the same sampling rate when working on any audio task.
If you plan to use custom audio data to fine-tune a pre-trained model, the sampling rate of your data should match the
sampling rate of the data the model was pre-trained on. The sampling rate determines the time interval between successive
audio samples, which impacts the temporal resolution of the audio data. Consider an example: a 5-second sound at a sampling
rate of 16,000 Hz will be represented as a series of 80,000 values, while the same 5-second sound at a sampling rate of
8,000 Hz will be represented as a series of 40,000 values. Transformer models that solve audio tasks treat examples as
sequences and rely on attention mechanisms to learn audio or multimodal representation. Since sequences are different for
audio examples at different sampling rates, it will be challenging for models to generalize between sampling rates.
`),Tt=l(lt,"STRONG",{});var qn=p(Tt);ni=n(qn,"Resampling"),qn.forEach(t),ri=n(lt," is the process of making the sampling rates match, and is part of "),Pe=l(lt,"A",{href:!0});var En=p(Pe);li=n(En,"preprocessing"),En.forEach(t),pi=n(lt," the audio data."),lt.forEach(t),ga=h(e),F=l(e,"H2",{class:!0});var ks=p(F);L=l(ks,"A",{id:!0,class:!0,href:!0});var $n=p(L);qt=l($n,"SPAN",{});var xn=p(qt);g(he.$$.fragment,xn),xn.forEach(t),$n.forEach(t),ui=h(ks),Et=l(ks,"SPAN",{});var Sn=p(Et);hi=n(Sn,"Amplitude and bit depth"),Sn.forEach(t),ks.forEach(t),va=h(e),Ae=l(e,"P",{});var zn=p(Ae);mi=n(zn,"While the sampling rate tells you how often the samples are taken, what exactly are the values in each sample?"),zn.forEach(t),wa=h(e),M=l(e,"P",{});var Ts=p(M);fi=n(Ts,"Sound is made by changes in air pressure at frequencies that are audible to humans. The "),$t=l(Ts,"STRONG",{});var Pn=p($t);ci=n(Pn,"amplitude"),Pn.forEach(t),di=n(Ts,` of a sound describes
the sound pressure level at any given instant and is measured in decibels (dB). We perceive the amplitude as loudness.
To give you an example, a normal speaking voice is under 60 dB, and a rock concert can be at around 125 dB, pushing the
limits of human hearing.`),Ts.forEach(t),ya=h(e),W=l(e,"P",{});var qs=p(W);gi=n(qs,"In digital audio, each audio sample records the amplitude of the audio wave at a point in time. The "),xt=l(qs,"STRONG",{});var An=p(xt);vi=n(An,"bit depth"),An.forEach(t),wi=n(qs,` of the
sample determines with how much precision this amplitude value can be described. The higher the bit depth, the more
faithfully the digital representation approximates the original continuous sound wave.`),qs.forEach(t),ba=h(e),Fe=l(e,"P",{});var Fn=p(Fe);yi=n(Fn,`The most common audio bit depths are 16-bit and 24-bit. Each is a binary term, representing the number of possible steps
to which the amplitude value can be quantized when it\u2019s converted from continuous to discrete: 65,536 steps for 16-bit audio,
a whopping 16,777,216 steps for 24-bit audio. Because quantizing involves rounding off the continuous value to a discrete
value, the sampling process introduces noise. The higher the bit depth, the smaller this quantization noise. In practice,
the quantization noise of 16-bit audio is already small enough to be inaudible, and using higher bit depths is generally
not necessary.`),Fn.forEach(t),_a=h(e),R=l(e,"P",{});var Es=p(R);bi=n(Es,`You may also come across 32-bit audio. This stores the samples as floating-point values, whereas 16-bit and 24-bit audio
use integer samples. The precision of a 32-bit floating-point value is 24 bits, giving it the same bit depth as 24-bit audio.
Floating-point audio samples are expected to lie within the [-1.0, 1.0] range. Since machine learning models naturally
work on floating-point data, the audio must first be converted into floating-point format before it can be used to train
the model. We\u2019ll see how to do this in the next section on `),He=l(Es,"A",{href:!0});var Hn=p(He);_i=n(Hn,"Preprocessing"),Hn.forEach(t),ki=n(Es,"."),Es.forEach(t),ka=h(e),Ie=l(e,"P",{});var In=p(Ie);Ti=n(In,`Just as with continuous audio signals, the amplitude of digital audio is typically expressed in decibels (dB). Since
human hearing is logarithmic in nature \u2014 our ears are more sensitive to small fluctuations in quiet sounds than in loud
sounds \u2014 the loudness of a sound is easier to interpret if the amplitudes are in decibels, which are also logarithmic.
The decibel scale for real-world audio starts at 0 dB, which represents the quietest possible sound humans can hear, and
louder sounds have larger values. However, for digital audio signals, 0 dB is the loudest possible amplitude, while all
other amplitudes are negative. As a quick rule of thumb: every -6 dB is a halving of the amplitude, and anything below -60 dB
is generally inaudible unless you really crank up the volume.`),In.forEach(t),Ta=h(e),H=l(e,"H2",{class:!0});var $s=p(H);Y=l($s,"A",{id:!0,class:!0,href:!0});var Dn=p(Y);St=l(Dn,"SPAN",{});var Cn=p(St);g(me.$$.fragment,Cn),Cn.forEach(t),Dn.forEach(t),qi=h($s),zt=l($s,"SPAN",{});var jn=p(zt);Ei=n(jn,"Audio as a waveform"),jn.forEach(t),$s.forEach(t),qa=h(e),x=l(e,"P",{});var pt=p(x);$i=n(pt,"You may have seen sounds visualized as a "),Pt=l(pt,"STRONG",{});var Nn=p(Pt);xi=n(Nn,"waveform"),Nn.forEach(t),Si=n(pt,`, which plots the sample values over time and illustrates the changes
in the sound\u2019s amplitude. The is also known as the `),At=l(pt,"EM",{});var Bn=p(At);zi=n(Bn,"time domain"),Bn.forEach(t),Pi=n(pt," representation of sound."),pt.forEach(t),Ea=h(e),De=l(e,"P",{});var On=p(De);Ai=n(On,`This type of visualization is useful for identifying specific features of the audio signal such as the timing of individual
sound events, the overall loudness of the signal, and any irregularities or noise present in the audio.`),On.forEach(t),$a=h(e),J=l(e,"P",{});var xs=p(J);Fi=n(xs,"To plot the waveform for an audio signal, we can use a Python library called "),Ft=l(xs,"CODE",{});var Gn=p(Ft);Hi=n(Gn,"librosa"),Gn.forEach(t),Ii=n(xs,":"),xs.forEach(t),xa=h(e),g(fe.$$.fragment,e),Sa=h(e),Ce=l(e,"P",{});var Ln=p(Ce);Di=n(Ln,"Let\u2019s take an example sound called \u201Ctrumpet\u201D that comes with the library:"),Ln.forEach(t),za=h(e),g(ce.$$.fragment,e),Pa=h(e),T=l(e,"P",{});var oe=p(T);Ci=n(oe,"The example is loaded as a tuple of audio time series (here we call it "),Ht=l(oe,"CODE",{});var Mn=p(Ht);ji=n(Mn,"array"),Mn.forEach(t),Ni=n(oe,"), and sampling rate ("),It=l(oe,"CODE",{});var Wn=p(It);Bi=n(Wn,"sampling_rate"),Wn.forEach(t),Oi=n(oe,`).
Let\u2019s take a look at this sound\u2019s waveform by using librosa\u2019s `),Dt=l(oe,"CODE",{});var Rn=p(Dt);Gi=n(Rn,"waveshow()"),Rn.forEach(t),Li=n(oe," function:"),oe.forEach(t),Aa=h(e),g(de.$$.fragment,e),Fa=h(e),je=l(e,"P",{});var Yn=p(je);Ne=l(Yn,"IMG",{src:!0,alt:!0}),Yn.forEach(t),Ha=h(e),Be=l(e,"P",{});var Jn=p(Be);Mi=n(Jn,`This plots the amplitude of the signal on the y-axis and time along the x-axis. In other words, each point corresponds
to a single sample value that was taken when this sound was sampled. Also note that librosa returns the audio as
floating-point values already, and that the amplitude values are indeed within the [-1.0, 1.0] range.`),Jn.forEach(t),Ia=h(e),Oe=l(e,"P",{});var Un=p(Oe);Wi=n(Un,`Visualizing the audio along with listening to it can be a useful tool for understanding the data you are working with.
You can see the shape of the signal, observe patterns, learn to spot noise or distortion. If you preprocess data in some
ways, such as normalization, resampling, or filtering, you can visually confirm that preprocessing steps have been applied as expected.
After training a model, you can also visualize samples where errors occur (e.g. in audio classification task) to debug
the issue.`),Un.forEach(t),Da=h(e),I=l(e,"H2",{class:!0});var Ss=p(I);U=l(Ss,"A",{id:!0,class:!0,href:!0});var Vn=p(U);Ct=l(Vn,"SPAN",{});var Kn=p(Ct);g(ge.$$.fragment,Kn),Kn.forEach(t),Vn.forEach(t),Ri=h(Ss),jt=l(Ss,"SPAN",{});var Qn=p(jt);Yi=n(Qn,"The frequency spectrum"),Qn.forEach(t),Ss.forEach(t),Ca=h(e),S=l(e,"P",{});var ut=p(S);Ji=n(ut,"Another way to visualize audio data is to plot the "),Nt=l(ut,"STRONG",{});var Xn=p(Nt);Ui=n(Xn,"frequency spectrum"),Xn.forEach(t),Vi=n(ut," of an audio signal, also known as the "),Bt=l(ut,"EM",{});var Zn=p(Bt);Ki=n(Zn,"frequency domain"),Zn.forEach(t),Qi=n(ut,`
representation. The spectrum is computed using the discrete Fourier transform or DFT. It describes the individual frequencies
that make up the signal and how strong they are.`),ut.forEach(t),ja=h(e),V=l(e,"P",{});var zs=p(V);Xi=n(zs,"Let\u2019s plot the frequency spectrum for the same trumpet sound by taking the DFT using numpy\u2019s "),Ot=l(zs,"CODE",{});var er=p(Ot);Zi=n(er,"rfft()"),er.forEach(t),eo=n(zs,` function. While it
is possible to plot the spectrum of the entire sound, it\u2019s more useful to look at a small region instead. Here we\u2019ll take
the DFT over the first 4096 samples, which is roughly the length of the first note being played:`),zs.forEach(t),Na=h(e),g(ve.$$.fragment,e),Ba=h(e),Ge=l(e,"P",{});var tr=p(Ge);Le=l(tr,"IMG",{src:!0,alt:!0}),tr.forEach(t),Oa=h(e),Me=l(e,"P",{});var ar=p(Me);to=n(ar,`This plots the strength of the various frequency components that are present in this audio segment. The frequency values are on
the x-axis, usually plotted on a logarithmic scale, while their amplitudes are on the y-axis.`),ar.forEach(t),Ga=h(e),We=l(e,"P",{});var sr=p(We);ao=n(sr,`The frequency spectrum that we plotted shows several peaks. These peaks correspond to the harmonics of the note that\u2019s
being played, with the higher harmonics being quieter. Since the first peak is at around 620 Hz, this is the frequency spectrum of an E\u266D note.`),sr.forEach(t),La=h(e),K=l(e,"P",{});var Ps=p(K);so=n(Ps,`The output of the DFT is an array of complex numbers, made up of real and imaginary components. Taking
the magnitude with `),Gt=l(Ps,"CODE",{});var ir=p(Gt);io=n(ir,"np.abs(dft)"),ir.forEach(t),oo=n(Ps,` extracts the amplitude information from the spectrogram. The angle between the real and
imaginary components provides the so-called phase spectrum, but this is often discarded in machine learning applications.`),Ps.forEach(t),Ma=h(e),z=l(e,"P",{});var ht=p(z);no=n(ht,"You used "),Lt=l(ht,"CODE",{});var or=p(Lt);ro=n(or,"librosa.amplitude_to_db()"),or.forEach(t),lo=n(ht,` to convert the amplitude values to the decibel scale, making it easier to see
the finer details in the spectrum. Sometimes people use the `),Mt=l(ht,"STRONG",{});var nr=p(Mt);po=n(nr,"power spectrum"),nr.forEach(t),uo=n(ht,`, which measures energy rather than amplitude;
this is simply a spectrum with the amplitude values squared.`),ht.forEach(t),Wa=h(e),g(Q.$$.fragment,e),Ra=h(e),Re=l(e,"P",{});var rr=p(Re);ho=n(rr,`The frequency spectrum of an audio signal contains the exact same information as its waveform \u2014 they are simply two different
ways of looking at the same data (here, the first 4096 samples from the trumpet sound). Where the waveform plots the amplitude
of the audio signal over time, the spectrum visualizes the amplitudes of the individual frequencies at a fixed point in time.`),rr.forEach(t),Ya=h(e),D=l(e,"H2",{class:!0});var As=p(D);X=l(As,"A",{id:!0,class:!0,href:!0});var lr=p(X);Wt=l(lr,"SPAN",{});var pr=p(Wt);g(we.$$.fragment,pr),pr.forEach(t),lr.forEach(t),mo=h(As),Rt=l(As,"SPAN",{});var ur=p(Rt);fo=n(ur,"Spectrogram"),ur.forEach(t),As.forEach(t),Ja=h(e),Z=l(e,"P",{});var Fs=p(Z);co=n(Fs,`What if we want to see how the frequencies in an audio signal change? The trumpet plays several notes and they all have
different frequencies. The problem is that the spectrum only shows a frozen snapshot of the frequencies at a given instant.
The solution is to take multiple DFTs, each covering only a small slice of time, and stack the resulting spectra together
into a `),Yt=l(Fs,"STRONG",{});var hr=p(Yt);go=n(hr,"spectrogram"),hr.forEach(t),vo=n(Fs,"."),Fs.forEach(t),Ua=h(e),Ye=l(e,"P",{});var mr=p(Ye);wo=n(mr,`A spectrogram plots the frequency content of an audio signal as it changes over time. It allows you to see time, frequency,
and amplitude all on one graph. The algorithm that performs this computation is the STFT or Short Time Fourier Transform.`),mr.forEach(t),Va=h(e),Je=l(e,"P",{});var fr=p(Je);yo=n(fr,`The spectrogram is one of the most informative audio tools available to you. For example, when working with a music recording,
you can see the various instruments and vocal tracks and how they contribute to the overall sound. In speech, you can
identify different vowel sounds as each vowel is characterized by particular frequencies.`),fr.forEach(t),Ka=h(e),P=l(e,"P",{});var mt=p(P);bo=n(mt,"Let\u2019s plot a spectrogram for the same trumpet sound, using librosa\u2019s "),Jt=l(mt,"CODE",{});var cr=p(Jt);_o=n(cr,"stft()"),cr.forEach(t),ko=n(mt," and "),Ut=l(mt,"CODE",{});var dr=p(Ut);To=n(dr,"specshow()"),dr.forEach(t),qo=n(mt," functions:"),mt.forEach(t),Qa=h(e),g(ye.$$.fragment,e),Xa=h(e),Ue=l(e,"P",{});var gr=p(Ue);Ve=l(gr,"IMG",{src:!0,alt:!0}),gr.forEach(t),Za=h(e),Ke=l(e,"P",{});var vr=p(Ke);Eo=n(vr,`In this plot, the x-axis represents time as in the waveform visualization but now the y-axis represents frequency in Hz.
The intensity of the color gives the amplitude or power of the frequency component at each point in time, measured in decibels (dB).`),vr.forEach(t),es=h(e),ee=l(e,"P",{});var Hs=p(ee);$o=n(Hs,`The spectrogram is created by taking short segments of the audio signal, typically lasting a few milliseconds, and calculating
the discrete Fourier transform of each segment to obtain its frequency spectrum. The resulting spectra are then stacked
together on the time axis to create the spectrogram. Each vertical slice in this image corresponds to a single frequency
spectrum, seen from the top. By default, `),Vt=l(Hs,"CODE",{});var wr=p(Vt);xo=n(wr,"librosa.stft()"),wr.forEach(t),So=n(Hs,` splits the audio signal into segments of 2048 samples, which
gives a good trade-off between frequency resolution and time resolution.`),Hs.forEach(t),ts=h(e),Qe=l(e,"P",{});var yr=p(Qe);zo=n(yr,`Since the spectrogram and the waveform are different views of the same data, it\u2019s possible to turn the spectrogram back
into the original waveform using the inverse STFT. However, this requires the phase information in addition to the amplitude
information. If the spectrogram was generated by a machine learning model, it typically only outputs the amplitudes. In
that case, we can use a phase reconstruction algorithm such as the classic Griffin-Lim algorithm, or using a neural network
called a vocoder, to reconstruct a waveform from the spectrogram.`),yr.forEach(t),as=h(e),Xe=l(e,"P",{});var br=p(Xe);Po=n(br,`Spectrograms aren\u2019t just used for visualization. Many machine learning models will take spectrograms as input \u2014 as opposed
to waveforms \u2014 and produce spectrograms as output.`),br.forEach(t),ss=h(e),Ze=l(e,"P",{});var _r=p(Ze);Ao=n(_r,"Now that we know what a spectrogram is and how it\u2019s made, let\u2019s take a look at a variant of it widely used for speech processing: the mel spectrogram."),_r.forEach(t),is=h(e),C=l(e,"H2",{class:!0});var Is=p(C);te=l(Is,"A",{id:!0,class:!0,href:!0});var kr=p(te);Kt=l(kr,"SPAN",{});var Tr=p(Kt);g(be.$$.fragment,Tr),Tr.forEach(t),kr.forEach(t),Fo=h(Is),Qt=l(Is,"SPAN",{});var qr=p(Qt);Ho=n(qr,"Mel spectrogram"),qr.forEach(t),Is.forEach(t),os=h(e),et=l(e,"P",{});var Er=p(et);Io=n(Er,`A mel spectrogram is a variation of the spectrogram that is commonly used in speech processing and machine learning tasks.
It is similar to a spectrogram in that it shows the frequency content of an audio signal over time, but on a different frequency axis.`),Er.forEach(t),ns=h(e),tt=l(e,"P",{});var $r=p(tt);Do=n($r,`In a standard spectrogram, the frequency axis is linear and is measured in hertz (Hz). However, the human auditory system
is more sensitive to changes in lower frequencies than higher frequencies, and this sensitivity decreases logarithmically
as frequency increases. The mel scale is a perceptual scale that approximates the non-linear frequency response of the human ear.`),$r.forEach(t),rs=h(e),at=l(e,"P",{});var xr=p(at);Co=n(xr,`To create a mel spectrogram, the STFT is used just like before, splitting the audio into short segments to obtain a sequence
of frequency spectra. Additionally, each spectrum is sent through a set of filters, the so-called mel filterbank, to
transform the frequencies to the mel scale.`),xr.forEach(t),ls=h(e),ae=l(e,"P",{});var Ds=p(ae);jo=n(Ds,"Let\u2019s see how we can plot a mel spectrogram using librosa\u2019s "),Xt=l(Ds,"CODE",{});var Sr=p(Xt);No=n(Sr,"melspectrogram()"),Sr.forEach(t),Bo=n(Ds," function, which performs all of those steps for us:"),Ds.forEach(t),ps=h(e),g(_e.$$.fragment,e),us=h(e),st=l(e,"P",{});var zr=p(st);it=l(zr,"IMG",{src:!0,alt:!0}),zr.forEach(t),hs=h(e),q=l(e,"P",{});var ne=p(q);Oo=n(ne,"In the example above, "),Zt=l(ne,"CODE",{});var Pr=p(Zt);Go=n(Pr,"n_mels"),Pr.forEach(t),Lo=n(ne,` stands for the number of mel bands to generate. The mel bands define a set of frequency
ranges that divide the spectrum into perceptually meaningful components, using a set of filters whose shape and spacing
are chosen to mimic the way the human ear responds to different frequencies. Common values for `),ea=l(ne,"CODE",{});var Ar=p(ea);Mo=n(Ar,"n_mels"),Ar.forEach(t),Wo=n(ne," are 40 or 80. "),ta=l(ne,"CODE",{});var Fr=p(ta);Ro=n(Fr,"fmax"),Fr.forEach(t),Yo=n(ne,`
indicates the highest frequency (in Hz) we care about.`),ne.forEach(t),ms=h(e),E=l(e,"P",{});var re=p(E);Jo=n(re,`Just as with a regular spectrogram, it\u2019s common practice to express the strength of the mel frequency components in
decibels. This is commonly referred to as a `),aa=l(re,"STRONG",{});var Hr=p(aa);Uo=n(Hr,"log-mel spectrogram"),Hr.forEach(t),Vo=n(re,`, because the conversion to decibels involves a
logarithmic operation. The above example used `),sa=l(re,"CODE",{});var Ir=p(sa);Ko=n(Ir,"librosa.power_to_db()"),Ir.forEach(t),Qo=n(re," as "),ia=l(re,"CODE",{});var Dr=p(ia);Xo=n(Dr,"librosa.feature.melspectrogram()"),Dr.forEach(t),Zo=n(re," creates a power spectrogram."),re.forEach(t),fs=h(e),g(se.$$.fragment,e),cs=h(e),ot=l(e,"P",{});var Cr=p(ot);en=n(Cr,`Creating a mel spectrogram is a lossy operation as it involves filtering the signal. Converting a mel spectrogram back
into a waveform is more difficult than doing this for a regular spectrogram, as it requires estimating the frequencies
that were thrown away. This is why machine learning models such as HiFiGAN vocoder are needed to produce a waveform from a mel
spectrogram.`),Cr.forEach(t),ds=h(e),nt=l(e,"P",{});var jr=p(nt);tn=n(jr,`Compared to a standard spectrogram, a mel spectrogram can capture more meaningful features of the audio signal for
human perception, making it a popular choice in tasks such as speech recognition, speaker identification, and music genre classification.`),jr.forEach(t),gs=h(e),rt=l(e,"P",{});var Nr=p(rt);an=n(Nr,"Now that you know how to visualize audio data examples, go ahead and try to see what your favorite sounds look like. :)"),Nr.forEach(t),this.h()},h(){m(f,"name","hf:doc:metadata"),m(f,"content",JSON.stringify(Ur)),m(j,"id","introduction-to-audio-data"),m(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(j,"href","#introduction-to-audio-data"),m(_,"class","relative group"),m(N,"id","sampling-and-sampling-rate"),m(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(N,"href","#sampling-and-sampling-rate"),m(A,"class","relative group"),na(xe.src,on="../../../assets/img/Signal_Sampling.png")||m(xe,"src",on),m(xe,"alt","Signal_Sampling.png"),m(ue,"href","https://en.wikipedia.org/wiki/Sampling_(signal_processing)"),m(ue,"rel","nofollow"),m(Pe,"href","preprocessing#resampling-the-audio-data"),m(L,"id","amplitude-and-bit-depth"),m(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(L,"href","#amplitude-and-bit-depth"),m(F,"class","relative group"),m(He,"href","preprocessing"),m(Y,"id","audio-as-a-waveform"),m(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Y,"href","#audio-as-a-waveform"),m(H,"class","relative group"),na(Ne.src,nn="../../../assets/img/waveform_plot.png")||m(Ne,"src",nn),m(Ne,"alt","waveform_plot.png"),m(U,"id","the-frequency-spectrum"),m(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(U,"href","#the-frequency-spectrum"),m(I,"class","relative group"),na(Le.src,rn="../../../assets/img/spectrum_plot.png")||m(Le,"src",rn),m(Le,"alt","spectrum_plot.png"),m(X,"id","spectrogram"),m(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(X,"href","#spectrogram"),m(D,"class","relative group"),na(Ve.src,ln="../../../assets/img/spectrogram_plot.png")||m(Ve,"src",ln),m(Ve,"alt","spectrogram_plot.png"),m(te,"id","mel-spectrogram"),m(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(te,"href","#mel-spectrogram"),m(C,"class","relative group"),na(it.src,pn="../../../assets/img/mel-spectrogram.png")||m(it,"src",pn),m(it,"alt","mel-spectrogram.png")},m(e,s){a(document.head,f),i(e,c,s),i(e,_,s),a(_,j),a(j,ct),v(le,ct,null),a(_,Cs),a(_,dt),a(dt,js),i(e,ra,s),i(e,Ee,s),a(Ee,Ns),i(e,la,s),i(e,k,s),a(k,Bs),a(k,gt),a(gt,Os),a(k,Gs),a(k,vt),a(vt,Ls),a(k,Ms),a(k,wt),a(wt,Ws),a(k,Rs),i(e,pa,s),i(e,$e,s),a($e,Ys),i(e,ua,s),i(e,A,s),a(A,N),a(N,yt),v(pe,yt,null),a(A,Js),a(A,bt),a(bt,Us),i(e,ha,s),i(e,B,s),a(B,Vs),a(B,_t),a(_t,Ks),a(B,Qs),i(e,ma,s),i(e,O,s),a(O,xe),a(O,Xs),a(O,Se),a(Se,Zs),a(Se,ue),a(ue,ei),i(e,fa,s),i(e,G,s),a(G,ti),a(G,kt),a(kt,ai),a(G,si),i(e,ca,s),i(e,ze,s),a(ze,ii),i(e,da,s),i(e,$,s),a($,oi),a($,Tt),a(Tt,ni),a($,ri),a($,Pe),a(Pe,li),a($,pi),i(e,ga,s),i(e,F,s),a(F,L),a(L,qt),v(he,qt,null),a(F,ui),a(F,Et),a(Et,hi),i(e,va,s),i(e,Ae,s),a(Ae,mi),i(e,wa,s),i(e,M,s),a(M,fi),a(M,$t),a($t,ci),a(M,di),i(e,ya,s),i(e,W,s),a(W,gi),a(W,xt),a(xt,vi),a(W,wi),i(e,ba,s),i(e,Fe,s),a(Fe,yi),i(e,_a,s),i(e,R,s),a(R,bi),a(R,He),a(He,_i),a(R,ki),i(e,ka,s),i(e,Ie,s),a(Ie,Ti),i(e,Ta,s),i(e,H,s),a(H,Y),a(Y,St),v(me,St,null),a(H,qi),a(H,zt),a(zt,Ei),i(e,qa,s),i(e,x,s),a(x,$i),a(x,Pt),a(Pt,xi),a(x,Si),a(x,At),a(At,zi),a(x,Pi),i(e,Ea,s),i(e,De,s),a(De,Ai),i(e,$a,s),i(e,J,s),a(J,Fi),a(J,Ft),a(Ft,Hi),a(J,Ii),i(e,xa,s),v(fe,e,s),i(e,Sa,s),i(e,Ce,s),a(Ce,Di),i(e,za,s),v(ce,e,s),i(e,Pa,s),i(e,T,s),a(T,Ci),a(T,Ht),a(Ht,ji),a(T,Ni),a(T,It),a(It,Bi),a(T,Oi),a(T,Dt),a(Dt,Gi),a(T,Li),i(e,Aa,s),v(de,e,s),i(e,Fa,s),i(e,je,s),a(je,Ne),i(e,Ha,s),i(e,Be,s),a(Be,Mi),i(e,Ia,s),i(e,Oe,s),a(Oe,Wi),i(e,Da,s),i(e,I,s),a(I,U),a(U,Ct),v(ge,Ct,null),a(I,Ri),a(I,jt),a(jt,Yi),i(e,Ca,s),i(e,S,s),a(S,Ji),a(S,Nt),a(Nt,Ui),a(S,Vi),a(S,Bt),a(Bt,Ki),a(S,Qi),i(e,ja,s),i(e,V,s),a(V,Xi),a(V,Ot),a(Ot,Zi),a(V,eo),i(e,Na,s),v(ve,e,s),i(e,Ba,s),i(e,Ge,s),a(Ge,Le),i(e,Oa,s),i(e,Me,s),a(Me,to),i(e,Ga,s),i(e,We,s),a(We,ao),i(e,La,s),i(e,K,s),a(K,so),a(K,Gt),a(Gt,io),a(K,oo),i(e,Ma,s),i(e,z,s),a(z,no),a(z,Lt),a(Lt,ro),a(z,lo),a(z,Mt),a(Mt,po),a(z,uo),i(e,Wa,s),v(Q,e,s),i(e,Ra,s),i(e,Re,s),a(Re,ho),i(e,Ya,s),i(e,D,s),a(D,X),a(X,Wt),v(we,Wt,null),a(D,mo),a(D,Rt),a(Rt,fo),i(e,Ja,s),i(e,Z,s),a(Z,co),a(Z,Yt),a(Yt,go),a(Z,vo),i(e,Ua,s),i(e,Ye,s),a(Ye,wo),i(e,Va,s),i(e,Je,s),a(Je,yo),i(e,Ka,s),i(e,P,s),a(P,bo),a(P,Jt),a(Jt,_o),a(P,ko),a(P,Ut),a(Ut,To),a(P,qo),i(e,Qa,s),v(ye,e,s),i(e,Xa,s),i(e,Ue,s),a(Ue,Ve),i(e,Za,s),i(e,Ke,s),a(Ke,Eo),i(e,es,s),i(e,ee,s),a(ee,$o),a(ee,Vt),a(Vt,xo),a(ee,So),i(e,ts,s),i(e,Qe,s),a(Qe,zo),i(e,as,s),i(e,Xe,s),a(Xe,Po),i(e,ss,s),i(e,Ze,s),a(Ze,Ao),i(e,is,s),i(e,C,s),a(C,te),a(te,Kt),v(be,Kt,null),a(C,Fo),a(C,Qt),a(Qt,Ho),i(e,os,s),i(e,et,s),a(et,Io),i(e,ns,s),i(e,tt,s),a(tt,Do),i(e,rs,s),i(e,at,s),a(at,Co),i(e,ls,s),i(e,ae,s),a(ae,jo),a(ae,Xt),a(Xt,No),a(ae,Bo),i(e,ps,s),v(_e,e,s),i(e,us,s),i(e,st,s),a(st,it),i(e,hs,s),i(e,q,s),a(q,Oo),a(q,Zt),a(Zt,Go),a(q,Lo),a(q,ea),a(ea,Mo),a(q,Wo),a(q,ta),a(ta,Ro),a(q,Yo),i(e,ms,s),i(e,E,s),a(E,Jo),a(E,aa),a(aa,Uo),a(E,Vo),a(E,sa),a(sa,Ko),a(E,Qo),a(E,ia),a(ia,Xo),a(E,Zo),i(e,fs,s),v(se,e,s),i(e,cs,s),i(e,ot,s),a(ot,en),i(e,ds,s),i(e,nt,s),a(nt,tn),i(e,gs,s),i(e,rt,s),a(rt,an),vs=!0},p(e,[s]){const ke={};s&2&&(ke.$$scope={dirty:s,ctx:e}),Q.$set(ke);const oa={};s&2&&(oa.$$scope={dirty:s,ctx:e}),se.$set(oa)},i(e){vs||(w(le.$$.fragment,e),w(pe.$$.fragment,e),w(he.$$.fragment,e),w(me.$$.fragment,e),w(fe.$$.fragment,e),w(ce.$$.fragment,e),w(de.$$.fragment,e),w(ge.$$.fragment,e),w(ve.$$.fragment,e),w(Q.$$.fragment,e),w(we.$$.fragment,e),w(ye.$$.fragment,e),w(be.$$.fragment,e),w(_e.$$.fragment,e),w(se.$$.fragment,e),vs=!0)},o(e){y(le.$$.fragment,e),y(pe.$$.fragment,e),y(he.$$.fragment,e),y(me.$$.fragment,e),y(fe.$$.fragment,e),y(ce.$$.fragment,e),y(de.$$.fragment,e),y(ge.$$.fragment,e),y(ve.$$.fragment,e),y(Q.$$.fragment,e),y(we.$$.fragment,e),y(ye.$$.fragment,e),y(be.$$.fragment,e),y(_e.$$.fragment,e),y(se.$$.fragment,e),vs=!1},d(e){t(f),e&&t(c),e&&t(_),b(le),e&&t(ra),e&&t(Ee),e&&t(la),e&&t(k),e&&t(pa),e&&t($e),e&&t(ua),e&&t(A),b(pe),e&&t(ha),e&&t(B),e&&t(ma),e&&t(O),e&&t(fa),e&&t(G),e&&t(ca),e&&t(ze),e&&t(da),e&&t($),e&&t(ga),e&&t(F),b(he),e&&t(va),e&&t(Ae),e&&t(wa),e&&t(M),e&&t(ya),e&&t(W),e&&t(ba),e&&t(Fe),e&&t(_a),e&&t(R),e&&t(ka),e&&t(Ie),e&&t(Ta),e&&t(H),b(me),e&&t(qa),e&&t(x),e&&t(Ea),e&&t(De),e&&t($a),e&&t(J),e&&t(xa),b(fe,e),e&&t(Sa),e&&t(Ce),e&&t(za),b(ce,e),e&&t(Pa),e&&t(T),e&&t(Aa),b(de,e),e&&t(Fa),e&&t(je),e&&t(Ha),e&&t(Be),e&&t(Ia),e&&t(Oe),e&&t(Da),e&&t(I),b(ge),e&&t(Ca),e&&t(S),e&&t(ja),e&&t(V),e&&t(Na),b(ve,e),e&&t(Ba),e&&t(Ge),e&&t(Oa),e&&t(Me),e&&t(Ga),e&&t(We),e&&t(La),e&&t(K),e&&t(Ma),e&&t(z),e&&t(Wa),b(Q,e),e&&t(Ra),e&&t(Re),e&&t(Ya),e&&t(D),b(we),e&&t(Ja),e&&t(Z),e&&t(Ua),e&&t(Ye),e&&t(Va),e&&t(Je),e&&t(Ka),e&&t(P),e&&t(Qa),b(ye,e),e&&t(Xa),e&&t(Ue),e&&t(Za),e&&t(Ke),e&&t(es),e&&t(ee),e&&t(ts),e&&t(Qe),e&&t(as),e&&t(Xe),e&&t(ss),e&&t(Ze),e&&t(is),e&&t(C),b(be),e&&t(os),e&&t(et),e&&t(ns),e&&t(tt),e&&t(rs),e&&t(at),e&&t(ls),e&&t(ae),e&&t(ps),b(_e,e),e&&t(us),e&&t(st),e&&t(hs),e&&t(q),e&&t(ms),e&&t(E),e&&t(fs),b(se,e),e&&t(cs),e&&t(ot),e&&t(ds),e&&t(nt),e&&t(gs),e&&t(rt)}}}const Ur={local:"introduction-to-audio-data",sections:[{local:"sampling-and-sampling-rate",title:"Sampling and sampling rate"},{local:"amplitude-and-bit-depth",title:"Amplitude and bit depth"},{local:"audio-as-a-waveform",title:"Audio as a waveform"},{local:"the-frequency-spectrum",title:"The frequency spectrum"},{local:"spectrogram",title:"Spectrogram"},{local:"mel-spectrogram",title:"Mel spectrogram"}],title:"Introduction to audio data"};function Vr(qe){return Wr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class el extends Or{constructor(f){super();Gr(this,f,Vr,Jr,Lr,{})}}export{el as default,Ur as metadata};
