import{S as Os,i as Ns,s as Ms,e as o,k as d,w as I,t,M as Ss,c as i,d as e,m as u,a as r,x as P,h as l,b as m,N as Hs,G as s,g as p,y as A,L as Bs,q as L,o as T,B as C,v as Us}from"../../chunks/vendor-hf-doc-builder.js";import{I as Ys}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as G}from"../../chunks/CodeBlock-hf-doc-builder.js";function zs(ls){let y,$a,w,b,la,O,ae,na,ee,Ea,W,se,ka,J,te,xa,N,Da,v,le,oa,ne,oe,Ia,q,ie,M,re,pe,Pa,c,de,ia,ue,ce,ra,he,fe,pa,me,_e,Aa,S,La,R,ge,Ta,H,Ca,K,ye,Oa,_,j,da,we,be,ua,ve,qe,je,Q,ca,$e,Ee,ke,V,ha,xe,De,Na,g,Ie,fa,Pe,Ae,ma,Le,Te,Ma,B,Sa,X,Ce,Ha,h,Oe,_a,Ne,Me,ga,Se,He,ya,Be,Ue,Ba,$,Ye,wa,ze,Fe,Ua,U,Ya,f,Ge,ba,We,Je,va,Re,Ke,qa,Qe,Ve,za,Y,Fa,Z,Xe,Ga,z,Wa,aa,ea,ns,Ja,E,Ze,F,as,es,Ra;return O=new Ys({}),N=new G({props:{code:"pip install datasets[audio]",highlighted:"pip install datasets[audio]"}}),S=new G({props:{code:`from datasets import load_dataset

minds = load_dataset("PolyAI/minds14", name="en-AU", split="train")
minds
Dataset(
    {
        features: [
            "path",
            "audio",
            "transcription",
            "english_transcription",
            "intent_class",
            "lang_id",
        ],
        num_rows: 654,
    }
)`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

minds = load_dataset(<span class="hljs-string">&quot;PolyAI/minds14&quot;</span>, name=<span class="hljs-string">&quot;en-AU&quot;</span>, split=<span class="hljs-string">&quot;train&quot;</span>)
minds
Dataset(
    {
        features: [
            <span class="hljs-string">&quot;path&quot;</span>,
            <span class="hljs-string">&quot;audio&quot;</span>,
            <span class="hljs-string">&quot;transcription&quot;</span>,
            <span class="hljs-string">&quot;english_transcription&quot;</span>,
            <span class="hljs-string">&quot;intent_class&quot;</span>,
            <span class="hljs-string">&quot;lang_id&quot;</span>,
        ],
        num_rows: <span class="hljs-number">654</span>,
    }
)`}}),H=new G({props:{code:`example = minds[0]
example
{
    "path": "/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav",
    "audio": {
        "path": "/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav",
        "array": array(
            [0.0, 0.00024414, -0.00024414, ..., -0.00024414, 0.00024414, 0.0012207],
            dtype=float32,
        ),
        "sampling_rate": 8000,
    },
    "transcription": "I would like to pay my electricity bill using my card can you please assist",
    "english_transcription": "I would like to pay my electricity bill using my card can you please assist",
    "intent_class": 13,
    "lang_id": 2,
}`,highlighted:`example = minds[<span class="hljs-number">0</span>]
example
{
    <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav&quot;</span>,
    <span class="hljs-string">&quot;audio&quot;</span>: {
        <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav&quot;</span>,
        <span class="hljs-string">&quot;array&quot;</span>: array(
            [<span class="hljs-number">0.0</span>, <span class="hljs-number">0.00024414</span>, -<span class="hljs-number">0.00024414</span>, ..., -<span class="hljs-number">0.00024414</span>, <span class="hljs-number">0.00024414</span>, <span class="hljs-number">0.0012207</span>],
            dtype=float32,
        ),
        <span class="hljs-string">&quot;sampling_rate&quot;</span>: <span class="hljs-number">8000</span>,
    },
    <span class="hljs-string">&quot;transcription&quot;</span>: <span class="hljs-string">&quot;I would like to pay my electricity bill using my card can you please assist&quot;</span>,
    <span class="hljs-string">&quot;english_transcription&quot;</span>: <span class="hljs-string">&quot;I would like to pay my electricity bill using my card can you please assist&quot;</span>,
    <span class="hljs-string">&quot;intent_class&quot;</span>: <span class="hljs-number">13</span>,
    <span class="hljs-string">&quot;lang_id&quot;</span>: <span class="hljs-number">2</span>,
}`}}),B=new G({props:{code:`id2label = minds.features["intent_class"].int2str
id2label(example["intent_class"])
"pay_bill"`,highlighted:`id2label = minds.features[<span class="hljs-string">&quot;intent_class&quot;</span>].int2str
id2label(example[<span class="hljs-string">&quot;intent_class&quot;</span>])
<span class="hljs-string">&quot;pay_bill&quot;</span>`}}),U=new G({props:{code:`columns_to_remove = ["lang_id", "english_transcription"]
minds = minds.remove_columns(columns_to_remove)
minds
Dataset({features: ["path", "audio", "transcription", "intent_class"], num_rows: 654})`,highlighted:`columns_to_remove = [<span class="hljs-string">&quot;lang_id&quot;</span>, <span class="hljs-string">&quot;english_transcription&quot;</span>]
minds = minds.remove_columns(columns_to_remove)
minds
Dataset({features: [<span class="hljs-string">&quot;path&quot;</span>, <span class="hljs-string">&quot;audio&quot;</span>, <span class="hljs-string">&quot;transcription&quot;</span>, <span class="hljs-string">&quot;intent_class&quot;</span>], num_rows: <span class="hljs-number">654</span>})`}}),Y=new G({props:{code:`import gradio as gr


def generate_audio():
    example = minds.shuffle()[0]
    audio = example["audio"]
    return (
        audio["sampling_rate"],
        audio["array"],
    ), id2label(example["intent_class"])


with gr.Blocks() as demo:
    with gr.Column():
        for _ in range(4):
            audio, label = generate_audio()
            output = gr.Audio(audio, label=label)

demo.launch(debug=True)`,highlighted:`<span class="hljs-keyword">import</span> gradio <span class="hljs-keyword">as</span> gr


<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_audio</span>():
    example = minds.shuffle()[<span class="hljs-number">0</span>]
    audio = example[<span class="hljs-string">&quot;audio&quot;</span>]
    <span class="hljs-keyword">return</span> (
        audio[<span class="hljs-string">&quot;sampling_rate&quot;</span>],
        audio[<span class="hljs-string">&quot;array&quot;</span>],
    ), id2label(example[<span class="hljs-string">&quot;intent_class&quot;</span>])


<span class="hljs-keyword">with</span> gr.Blocks() <span class="hljs-keyword">as</span> demo:
    <span class="hljs-keyword">with</span> gr.Column():
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">4</span>):
            audio, label = generate_audio()
            output = gr.Audio(audio, label=label)

demo.launch(debug=<span class="hljs-literal">True</span>)`}}),z=new G({props:{code:`import librosa
import matplotlib.pyplot as plt
import librosa.display

array = example["audio"]["array"]
sampling_rate = example["audio"]["sampling_rate"]

plt.figure().set_figwidth(12)
librosa.display.waveshow(array, sr=sampling_rate)`,highlighted:`<span class="hljs-keyword">import</span> librosa
<span class="hljs-keyword">import</span> matplotlib.pyplot <span class="hljs-keyword">as</span> plt
<span class="hljs-keyword">import</span> librosa.display

array = example[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>]
sampling_rate = example[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;sampling_rate&quot;</span>]

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
librosa.display.waveshow(array, sr=sampling_rate)`}}),{c(){y=o("meta"),$a=d(),w=o("h1"),b=o("a"),la=o("span"),I(O.$$.fragment),ae=d(),na=o("span"),ee=t("Load and explore an audio dataset"),Ea=d(),W=o("p"),se=t(`In this course we will use the \u{1F917} Datasets library to work with audio datasets. \u{1F917} Datasets is an open-source library for
downloading and preparing datasets from all modalities including audio. The library offers easy access to an unparalleled
selection of machine learning datasets publicly available on Hugging Face Hub. Moreover, \u{1F917} Datasets includes multiple
features tailored to audio datasets that simplify working with such datasets for both researchers and practitioners.`),ka=d(),J=o("p"),te=t("To begin working with audio datasets, make sure you have the \u{1F917} Datasets library installed:"),xa=d(),I(N.$$.fragment),Da=d(),v=o("p"),le=t(`One of the key defining features of \u{1F917} Datasets is the ability to download and prepare a dataset in just one line of
Python code using the `),oa=o("code"),ne=t("load_dataset()"),oe=t(" function."),Ia=d(),q=o("p"),ie=t("Let\u2019s load and explore and audio dataset called "),M=o("a"),re=t("MINDS-14"),pe=t(`, which contains
recordings of people asking an e-banking system questions in several languages and dialects.`),Pa=d(),c=o("p"),de=t("To load the MINDS-14 dataset, we need to copy the dataset\u2019s identifier on the Hub ("),ia=o("code"),ue=t("PolyAI/minds14"),ce=t(`) and pass it
to the `),ra=o("code"),he=t("load_dataset"),fe=t(" function. We\u2019ll also specify that we\u2019re only interested in the Australian subset ("),pa=o("code"),me=t("en-AU"),_e=t(`) of
the data, and limit it to the training split:`),Aa=d(),I(S.$$.fragment),La=d(),R=o("p"),ge=t(`The dataset contains 654 audio files, each of which is accompanied by a transcription, an English translation, and a label
indicating the intent behind the person\u2019s query. The audio column contains the raw audio data. Let\u2019s take a closer look
at one of the examples:`),Ta=d(),I(H.$$.fragment),Ca=d(),K=o("p"),ye=t("You may notice that the audio column contains several features. Here\u2019s what they are:"),Oa=d(),_=o("ul"),j=o("li"),da=o("code"),we=t("path"),be=t(": the path to the audio file ("),ua=o("code"),ve=t("*.wav"),qe=t(" in this case)."),je=d(),Q=o("li"),ca=o("code"),$e=t("array"),Ee=t(": The decoded audio data, represented as a 1-dimensional NumPy array."),ke=d(),V=o("li"),ha=o("code"),xe=t("sampling_rate"),De=t(". The sampling rate of the audio file (8,000 Hz in this example)."),Na=d(),g=o("p"),Ie=t("The "),fa=o("code"),Pe=t("intent_class"),Ae=t(` is a classification category of the audio recording. To convert this number into a meaningful string,
we can use the `),ma=o("code"),Le=t("int2str()"),Te=t(" method:"),Ma=d(),I(B.$$.fragment),Sa=d(),X=o("p"),Ce=t(`If you look at the transcription feature, you can see that the audio file indeed has recorded a person asking a question
about paying a bill.`),Ha=d(),h=o("p"),Oe=t(`If you plan to train an audio classifier on this subset of data, you may not necessarily need all of the features. For example,
the `),_a=o("code"),Ne=t("lang_id"),Me=t(" is going to have the same value for all examples, and won\u2019t be useful. The "),ga=o("code"),Se=t("english_transcription"),He=t(` will likely
duplicate the `),ya=o("code"),Be=t("transcription"),Ue=t(" in this subset, so we can safely remove them."),Ba=d(),$=o("p"),Ye=t("You can easily remove irrelevant features using \u{1F917} Datasets\u2019 "),wa=o("code"),ze=t("remove_columns"),Fe=t(" method:"),Ua=d(),I(U.$$.fragment),Ya=d(),f=o("p"),Ge=t("Now that we\u2019ve loaded and inspected the raw contents of the dataset, let\u2019s listen to a few examples! We\u2019ll use the "),ba=o("code"),We=t("Blocks"),Je=t(`
and `),va=o("code"),Re=t("Audio"),Ke=t(" features from "),qa=o("code"),Qe=t("Gradio"),Ve=t(" to decode a few random samples from the dataset:"),za=d(),I(Y.$$.fragment),Fa=d(),Z=o("p"),Xe=t("If you\u2019d like to, you can also visualize some of the examples. Let\u2019s plot the waveform for the first example."),Ga=d(),I(z.$$.fragment),Wa=d(),aa=o("p"),ea=o("img"),Ja=d(),E=o("p"),Ze=t(`Try it out! Download another dialect or language of the MINDS-14 dataset, listen and visualize some examples to get a sense
of the variation in the whole dataset. You can find the full list of available languages `),F=o("a"),as=t("here"),es=t("."),this.h()},l(a){const n=Ss('[data-svelte="svelte-1phssyn"]',document.head);y=i(n,"META",{name:!0,content:!0}),n.forEach(e),$a=u(a),w=i(a,"H1",{class:!0});var Ka=r(w);b=i(Ka,"A",{id:!0,class:!0,href:!0});var os=r(b);la=i(os,"SPAN",{});var is=r(la);P(O.$$.fragment,is),is.forEach(e),os.forEach(e),ae=u(Ka),na=i(Ka,"SPAN",{});var rs=r(na);ee=l(rs,"Load and explore an audio dataset"),rs.forEach(e),Ka.forEach(e),Ea=u(a),W=i(a,"P",{});var ps=r(W);se=l(ps,`In this course we will use the \u{1F917} Datasets library to work with audio datasets. \u{1F917} Datasets is an open-source library for
downloading and preparing datasets from all modalities including audio. The library offers easy access to an unparalleled
selection of machine learning datasets publicly available on Hugging Face Hub. Moreover, \u{1F917} Datasets includes multiple
features tailored to audio datasets that simplify working with such datasets for both researchers and practitioners.`),ps.forEach(e),ka=u(a),J=i(a,"P",{});var ds=r(J);te=l(ds,"To begin working with audio datasets, make sure you have the \u{1F917} Datasets library installed:"),ds.forEach(e),xa=u(a),P(N.$$.fragment,a),Da=u(a),v=i(a,"P",{});var Qa=r(v);le=l(Qa,`One of the key defining features of \u{1F917} Datasets is the ability to download and prepare a dataset in just one line of
Python code using the `),oa=i(Qa,"CODE",{});var us=r(oa);ne=l(us,"load_dataset()"),us.forEach(e),oe=l(Qa," function."),Qa.forEach(e),Ia=u(a),q=i(a,"P",{});var Va=r(q);ie=l(Va,"Let\u2019s load and explore and audio dataset called "),M=i(Va,"A",{href:!0,rel:!0});var cs=r(M);re=l(cs,"MINDS-14"),cs.forEach(e),pe=l(Va,`, which contains
recordings of people asking an e-banking system questions in several languages and dialects.`),Va.forEach(e),Pa=u(a),c=i(a,"P",{});var k=r(c);de=l(k,"To load the MINDS-14 dataset, we need to copy the dataset\u2019s identifier on the Hub ("),ia=i(k,"CODE",{});var hs=r(ia);ue=l(hs,"PolyAI/minds14"),hs.forEach(e),ce=l(k,`) and pass it
to the `),ra=i(k,"CODE",{});var fs=r(ra);he=l(fs,"load_dataset"),fs.forEach(e),fe=l(k," function. We\u2019ll also specify that we\u2019re only interested in the Australian subset ("),pa=i(k,"CODE",{});var ms=r(pa);me=l(ms,"en-AU"),ms.forEach(e),_e=l(k,`) of
the data, and limit it to the training split:`),k.forEach(e),Aa=u(a),P(S.$$.fragment,a),La=u(a),R=i(a,"P",{});var _s=r(R);ge=l(_s,`The dataset contains 654 audio files, each of which is accompanied by a transcription, an English translation, and a label
indicating the intent behind the person\u2019s query. The audio column contains the raw audio data. Let\u2019s take a closer look
at one of the examples:`),_s.forEach(e),Ta=u(a),P(H.$$.fragment,a),Ca=u(a),K=i(a,"P",{});var gs=r(K);ye=l(gs,"You may notice that the audio column contains several features. Here\u2019s what they are:"),gs.forEach(e),Oa=u(a),_=i(a,"UL",{});var sa=r(_);j=i(sa,"LI",{});var ja=r(j);da=i(ja,"CODE",{});var ys=r(da);we=l(ys,"path"),ys.forEach(e),be=l(ja,": the path to the audio file ("),ua=i(ja,"CODE",{});var ws=r(ua);ve=l(ws,"*.wav"),ws.forEach(e),qe=l(ja," in this case)."),ja.forEach(e),je=u(sa),Q=i(sa,"LI",{});var ss=r(Q);ca=i(ss,"CODE",{});var bs=r(ca);$e=l(bs,"array"),bs.forEach(e),Ee=l(ss,": The decoded audio data, represented as a 1-dimensional NumPy array."),ss.forEach(e),ke=u(sa),V=i(sa,"LI",{});var ts=r(V);ha=i(ts,"CODE",{});var vs=r(ha);xe=l(vs,"sampling_rate"),vs.forEach(e),De=l(ts,". The sampling rate of the audio file (8,000 Hz in this example)."),ts.forEach(e),sa.forEach(e),Na=u(a),g=i(a,"P",{});var ta=r(g);Ie=l(ta,"The "),fa=i(ta,"CODE",{});var qs=r(fa);Pe=l(qs,"intent_class"),qs.forEach(e),Ae=l(ta,` is a classification category of the audio recording. To convert this number into a meaningful string,
we can use the `),ma=i(ta,"CODE",{});var js=r(ma);Le=l(js,"int2str()"),js.forEach(e),Te=l(ta," method:"),ta.forEach(e),Ma=u(a),P(B.$$.fragment,a),Sa=u(a),X=i(a,"P",{});var $s=r(X);Ce=l($s,`If you look at the transcription feature, you can see that the audio file indeed has recorded a person asking a question
about paying a bill.`),$s.forEach(e),Ha=u(a),h=i(a,"P",{});var x=r(h);Oe=l(x,`If you plan to train an audio classifier on this subset of data, you may not necessarily need all of the features. For example,
the `),_a=i(x,"CODE",{});var Es=r(_a);Ne=l(Es,"lang_id"),Es.forEach(e),Me=l(x," is going to have the same value for all examples, and won\u2019t be useful. The "),ga=i(x,"CODE",{});var ks=r(ga);Se=l(ks,"english_transcription"),ks.forEach(e),He=l(x,` will likely
duplicate the `),ya=i(x,"CODE",{});var xs=r(ya);Be=l(xs,"transcription"),xs.forEach(e),Ue=l(x," in this subset, so we can safely remove them."),x.forEach(e),Ba=u(a),$=i(a,"P",{});var Xa=r($);Ye=l(Xa,"You can easily remove irrelevant features using \u{1F917} Datasets\u2019 "),wa=i(Xa,"CODE",{});var Ds=r(wa);ze=l(Ds,"remove_columns"),Ds.forEach(e),Fe=l(Xa," method:"),Xa.forEach(e),Ua=u(a),P(U.$$.fragment,a),Ya=u(a),f=i(a,"P",{});var D=r(f);Ge=l(D,"Now that we\u2019ve loaded and inspected the raw contents of the dataset, let\u2019s listen to a few examples! We\u2019ll use the "),ba=i(D,"CODE",{});var Is=r(ba);We=l(Is,"Blocks"),Is.forEach(e),Je=l(D,`
and `),va=i(D,"CODE",{});var Ps=r(va);Re=l(Ps,"Audio"),Ps.forEach(e),Ke=l(D," features from "),qa=i(D,"CODE",{});var As=r(qa);Qe=l(As,"Gradio"),As.forEach(e),Ve=l(D," to decode a few random samples from the dataset:"),D.forEach(e),za=u(a),P(Y.$$.fragment,a),Fa=u(a),Z=i(a,"P",{});var Ls=r(Z);Xe=l(Ls,"If you\u2019d like to, you can also visualize some of the examples. Let\u2019s plot the waveform for the first example."),Ls.forEach(e),Ga=u(a),P(z.$$.fragment,a),Wa=u(a),aa=i(a,"P",{});var Ts=r(aa);ea=i(Ts,"IMG",{src:!0,alt:!0}),Ts.forEach(e),Ja=u(a),E=i(a,"P",{});var Za=r(E);Ze=l(Za,`Try it out! Download another dialect or language of the MINDS-14 dataset, listen and visualize some examples to get a sense
of the variation in the whole dataset. You can find the full list of available languages `),F=i(Za,"A",{href:!0,rel:!0});var Cs=r(F);as=l(Cs,"here"),Cs.forEach(e),es=l(Za,"."),Za.forEach(e),this.h()},h(){m(y,"name","hf:doc:metadata"),m(y,"content",JSON.stringify(Fs)),m(b,"id","load-and-explore-an-audio-dataset"),m(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(b,"href","#load-and-explore-an-audio-dataset"),m(w,"class","relative group"),m(M,"href","https://huggingface.co/datasets/PolyAI/minds14"),m(M,"rel","nofollow"),Hs(ea.src,ns="../../assets/img/waveform_unit1.png")||m(ea,"src",ns),m(ea,"alt","waveform_unit1.png"),m(F,"href","https://huggingface.co/datasets/PolyAI/minds14"),m(F,"rel","nofollow")},m(a,n){s(document.head,y),p(a,$a,n),p(a,w,n),s(w,b),s(b,la),A(O,la,null),s(w,ae),s(w,na),s(na,ee),p(a,Ea,n),p(a,W,n),s(W,se),p(a,ka,n),p(a,J,n),s(J,te),p(a,xa,n),A(N,a,n),p(a,Da,n),p(a,v,n),s(v,le),s(v,oa),s(oa,ne),s(v,oe),p(a,Ia,n),p(a,q,n),s(q,ie),s(q,M),s(M,re),s(q,pe),p(a,Pa,n),p(a,c,n),s(c,de),s(c,ia),s(ia,ue),s(c,ce),s(c,ra),s(ra,he),s(c,fe),s(c,pa),s(pa,me),s(c,_e),p(a,Aa,n),A(S,a,n),p(a,La,n),p(a,R,n),s(R,ge),p(a,Ta,n),A(H,a,n),p(a,Ca,n),p(a,K,n),s(K,ye),p(a,Oa,n),p(a,_,n),s(_,j),s(j,da),s(da,we),s(j,be),s(j,ua),s(ua,ve),s(j,qe),s(_,je),s(_,Q),s(Q,ca),s(ca,$e),s(Q,Ee),s(_,ke),s(_,V),s(V,ha),s(ha,xe),s(V,De),p(a,Na,n),p(a,g,n),s(g,Ie),s(g,fa),s(fa,Pe),s(g,Ae),s(g,ma),s(ma,Le),s(g,Te),p(a,Ma,n),A(B,a,n),p(a,Sa,n),p(a,X,n),s(X,Ce),p(a,Ha,n),p(a,h,n),s(h,Oe),s(h,_a),s(_a,Ne),s(h,Me),s(h,ga),s(ga,Se),s(h,He),s(h,ya),s(ya,Be),s(h,Ue),p(a,Ba,n),p(a,$,n),s($,Ye),s($,wa),s(wa,ze),s($,Fe),p(a,Ua,n),A(U,a,n),p(a,Ya,n),p(a,f,n),s(f,Ge),s(f,ba),s(ba,We),s(f,Je),s(f,va),s(va,Re),s(f,Ke),s(f,qa),s(qa,Qe),s(f,Ve),p(a,za,n),A(Y,a,n),p(a,Fa,n),p(a,Z,n),s(Z,Xe),p(a,Ga,n),A(z,a,n),p(a,Wa,n),p(a,aa,n),s(aa,ea),p(a,Ja,n),p(a,E,n),s(E,Ze),s(E,F),s(F,as),s(E,es),Ra=!0},p:Bs,i(a){Ra||(L(O.$$.fragment,a),L(N.$$.fragment,a),L(S.$$.fragment,a),L(H.$$.fragment,a),L(B.$$.fragment,a),L(U.$$.fragment,a),L(Y.$$.fragment,a),L(z.$$.fragment,a),Ra=!0)},o(a){T(O.$$.fragment,a),T(N.$$.fragment,a),T(S.$$.fragment,a),T(H.$$.fragment,a),T(B.$$.fragment,a),T(U.$$.fragment,a),T(Y.$$.fragment,a),T(z.$$.fragment,a),Ra=!1},d(a){e(y),a&&e($a),a&&e(w),C(O),a&&e(Ea),a&&e(W),a&&e(ka),a&&e(J),a&&e(xa),C(N,a),a&&e(Da),a&&e(v),a&&e(Ia),a&&e(q),a&&e(Pa),a&&e(c),a&&e(Aa),C(S,a),a&&e(La),a&&e(R),a&&e(Ta),C(H,a),a&&e(Ca),a&&e(K),a&&e(Oa),a&&e(_),a&&e(Na),a&&e(g),a&&e(Ma),C(B,a),a&&e(Sa),a&&e(X),a&&e(Ha),a&&e(h),a&&e(Ba),a&&e($),a&&e(Ua),C(U,a),a&&e(Ya),a&&e(f),a&&e(za),C(Y,a),a&&e(Fa),a&&e(Z),a&&e(Ga),C(z,a),a&&e(Wa),a&&e(aa),a&&e(Ja),a&&e(E)}}}const Fs={local:"load-and-explore-an-audio-dataset",title:"Load and explore an audio dataset"};function Gs(ls){return Us(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ks extends Os{constructor(y){super();Ns(this,y,Gs,zs,Ms,{})}}export{Ks as default,Fs as metadata};
