import{S as Ms,i as Us,s as Ys,e as n,k as h,w as c,t as i,M as Bs,c as r,d as t,m as u,a as p,x as g,h as l,b as d,N as Xs,G as a,g as o,y as w,q as _,o as y,B as v,v as Gs}from"../../chunks/vendor-hf-doc-builder.js";import{T as Js}from"../../chunks/Tip-hf-doc-builder.js";import{I as Mt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";function Ks(Ue){let f;return{c(){f=i(`\u{1F4A1} Some background on resampling: If an audio signal has been sampled at 8 kHz, so that it has 8000 sample readings per
second, we know that the audio does not contain any frequencies over 4 kHz. This is guaranteed by the Nyquist sampling
theorem. Because of this, we can be certain that in between the sampling points the original continuous signal always
makes a smooth curve. Upsampling to a higher sampling rate is then a matter of calculating additional sample values that go in between
the existing ones, by approximating this curve. Downsampling, however, requires that we first filter out any frequencies
that would be higher than the new Nyquist limit, before estimating the new sample points. In other words, you can't
downsample by a factor 2x by simply throwing away every other sample \u2014 this will create distortions in the signal called
aliases. Doing resampling correctly is tricky and best left to well-tested libraries such as librosa or \u{1F917} Datasets.`)},l(x){f=l(x,`\u{1F4A1} Some background on resampling: If an audio signal has been sampled at 8 kHz, so that it has 8000 sample readings per
second, we know that the audio does not contain any frequencies over 4 kHz. This is guaranteed by the Nyquist sampling
theorem. Because of this, we can be certain that in between the sampling points the original continuous signal always
makes a smooth curve. Upsampling to a higher sampling rate is then a matter of calculating additional sample values that go in between
the existing ones, by approximating this curve. Downsampling, however, requires that we first filter out any frequencies
that would be higher than the new Nyquist limit, before estimating the new sample points. In other words, you can't
downsample by a factor 2x by simply throwing away every other sample \u2014 this will create distortions in the signal called
aliases. Doing resampling correctly is tricky and best left to well-tested libraries such as librosa or \u{1F917} Datasets.`)},m(x,b){o(x,f,b)},d(x){x&&t(f)}}}function Qs(Ue){let f,x,b,A,be,U,Ut,xe,Yt,Ye,re,Bt,Be,$,$e,Xt,Gt,ke,Jt,Kt,qe,Qt,Xe,q,D,Ee,Y,Vt,je,Zt,Ge,T,ea,Pe,ta,aa,Je,ie,sa,Ke,I,oa,Ae,na,ra,Qe,B,Ve,N,ia,De,la,pa,Ze,X,et,le,ha,tt,S,at,E,W,Te,G,ua,Ie,da,st,pe,fa,ot,m,ma,Ne,ca,ga,Se,wa,_a,We,ya,va,Oe,ba,xa,nt,J,rt,he,$a,it,K,lt,ue,ka,pt,j,O,Le,Q,qa,ze,Ea,ht,de,ja,ut,L,Pa,V,Aa,Da,dt,fe,Ta,ft,me,Ia,mt,ce,Na,ct,Z,gt,z,Sa,Ce,Wa,Oa,wt,ee,_t,ge,La,yt,te,vt,C,za,He,Ca,Ha,bt,H,Fa,Fe,Ra,Ma,xt,ae,$t,we,_e,es,kt,ye,Ua,qt,F,Ya,se,Ba,Xa,Et,R,Ga,Re,Ja,Ka,jt,oe,Pt,M,Qa,Me,Va,Za,At;return U=new Mt({}),Y=new Mt({}),B=new P({props:{code:`from datasets import Audio

minds = minds.cast_column("audio", Audio(sampling_rate=16_000))`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Audio

minds = minds.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, Audio(sampling_rate=<span class="hljs-number">16_000</span>))`}}),X=new P({props:{code:`minds[0]
{
    "path": "/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav",
    "audio": {
        "path": "/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav",
        "array": array(
            [
                2.0634243e-05,
                1.9437837e-04,
                2.2419340e-04,
                ...,
                9.3852862e-04,
                1.1302452e-03,
                7.1531429e-04,
            ],
            dtype=float32,
        ),
        "sampling_rate": 16000,
    },
    "transcription": "I would like to pay my electricity bill using my card can you please assist",
    "intent_class": 13,
}`,highlighted:`minds[<span class="hljs-number">0</span>]
{
    <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav&quot;</span>,
    <span class="hljs-string">&quot;audio&quot;</span>: {
        <span class="hljs-string">&quot;path&quot;</span>: <span class="hljs-string">&quot;/root/.cache/huggingface/datasets/downloads/extracted/f14948e0e84be638dd7943ac36518a4cf3324e8b7aa331c5ab11541518e9368c/en-AU~PAY_BILL/response_4.wav&quot;</span>,
        <span class="hljs-string">&quot;array&quot;</span>: array(
            [
                <span class="hljs-number">2.0634243e-05</span>,
                <span class="hljs-number">1.9437837e-04</span>,
                <span class="hljs-number">2.2419340e-04</span>,
                ...,
                <span class="hljs-number">9.3852862e-04</span>,
                <span class="hljs-number">1.1302452e-03</span>,
                <span class="hljs-number">7.1531429e-04</span>,
            ],
            dtype=float32,
        ),
        <span class="hljs-string">&quot;sampling_rate&quot;</span>: <span class="hljs-number">16000</span>,
    },
    <span class="hljs-string">&quot;transcription&quot;</span>: <span class="hljs-string">&quot;I would like to pay my electricity bill using my card can you please assist&quot;</span>,
    <span class="hljs-string">&quot;intent_class&quot;</span>: <span class="hljs-number">13</span>,
}`}}),S=new Js({props:{$$slots:{default:[Ks]},$$scope:{ctx:Ue}}}),G=new Mt({}),J=new P({props:{code:`MAX_DURATION_IN_SECONDS = 20.0


def is_audio_length_in_range(input_length):
    return input_length < MAX_DURATION_IN_SECONDS`,highlighted:`MAX_DURATION_IN_SECONDS = <span class="hljs-number">20.0</span>


<span class="hljs-keyword">def</span> <span class="hljs-title function_">is_audio_length_in_range</span>(<span class="hljs-params">input_length</span>):
    <span class="hljs-keyword">return</span> input_length &lt; MAX_DURATION_IN_SECONDS`}}),K=new P({props:{code:`# use librosa to get example's duration from the audio file
new_column = [librosa.get_duration(filename=x) for x in minds["path"]]
minds = minds.add_column("duration", new_column)

# use \u{1F917} Datasets' \`filter\` method to apply the filtering function
minds = minds.filter(is_audio_length_in_range, input_columns=["duration"])

# remove the temporary helper column
minds = minds.remove_columns(["duration"])
minds
Dataset({features: ["path", "audio", "transcription", "intent_class"], num_rows: 624})`,highlighted:`<span class="hljs-comment"># use librosa to get example&#x27;s duration from the audio file</span>
new_column = [librosa.get_duration(filename=x) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> minds[<span class="hljs-string">&quot;path&quot;</span>]]
minds = minds.add_column(<span class="hljs-string">&quot;duration&quot;</span>, new_column)

<span class="hljs-comment"># use \u{1F917} Datasets&#x27; \`filter\` method to apply the filtering function</span>
minds = minds.<span class="hljs-built_in">filter</span>(is_audio_length_in_range, input_columns=[<span class="hljs-string">&quot;duration&quot;</span>])

<span class="hljs-comment"># remove the temporary helper column</span>
minds = minds.remove_columns([<span class="hljs-string">&quot;duration&quot;</span>])
minds
Dataset({features: [<span class="hljs-string">&quot;path&quot;</span>, <span class="hljs-string">&quot;audio&quot;</span>, <span class="hljs-string">&quot;transcription&quot;</span>, <span class="hljs-string">&quot;intent_class&quot;</span>], num_rows: <span class="hljs-number">624</span>})`}}),Q=new Mt({}),Z=new P({props:{code:`from transformers import WhisperFeatureExtractor

feature_extractor = WhisperFeatureExtractor.from_pretrained("openai/whisper-small")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> WhisperFeatureExtractor

feature_extractor = WhisperFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;openai/whisper-small&quot;</span>)`}}),ee=new P({props:{code:`def prepare_dataset(example):
    audio = example["audio"]
    features = feature_extractor(
        audio["array"], sampling_rate=audio["sampling_rate"], padding=True
    )
    return features`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">prepare_dataset</span>(<span class="hljs-params">example</span>):
    audio = example[<span class="hljs-string">&quot;audio&quot;</span>]
    features = feature_extractor(
        audio[<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=audio[<span class="hljs-string">&quot;sampling_rate&quot;</span>], padding=<span class="hljs-literal">True</span>
    )
    <span class="hljs-keyword">return</span> features`}}),te=new P({props:{code:`minds = minds.map(prepare_dataset)
minds
Dataset(
    {
        features: ["path", "audio", "transcription", "intent_class", "input_features"],
        num_rows: 624,
    }
)`,highlighted:`minds = minds.<span class="hljs-built_in">map</span>(prepare_dataset)
minds
Dataset(
    {
        features: [<span class="hljs-string">&quot;path&quot;</span>, <span class="hljs-string">&quot;audio&quot;</span>, <span class="hljs-string">&quot;transcription&quot;</span>, <span class="hljs-string">&quot;intent_class&quot;</span>, <span class="hljs-string">&quot;input_features&quot;</span>],
        num_rows: <span class="hljs-number">624</span>,
    }
)`}}),ae=new P({props:{code:`input_features = example["input_features"]

plt.figure().set_figwidth(12)
librosa.display.specshow(
    np.asarray(input_features[0]),
    x_axis="time",
    y_axis="mel",
    sr=sampling_rate,
    hop_length=hop_length,
)
plt.colorbar()`,highlighted:`input_features = example[<span class="hljs-string">&quot;input_features&quot;</span>]

plt.figure().set_figwidth(<span class="hljs-number">12</span>)
librosa.display.specshow(
    np.asarray(input_features[<span class="hljs-number">0</span>]),
    x_axis=<span class="hljs-string">&quot;time&quot;</span>,
    y_axis=<span class="hljs-string">&quot;mel&quot;</span>,
    sr=sampling_rate,
    hop_length=hop_length,
)
plt.colorbar()`}}),oe=new P({props:{code:`from transformers import AutoProcessor

processor = AutoProcessor.from_pretrained("openai/whisper-small")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor

processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;openai/whisper-small&quot;</span>)`}}),{c(){f=n("meta"),x=h(),b=n("h1"),A=n("a"),be=n("span"),c(U.$$.fragment),Ut=h(),xe=n("span"),Yt=i("Preprocessing an audio dataset"),Ye=h(),re=n("p"),Bt=i(`Loading a dataset with \u{1F917} Datasets is just half of the fun. If you plan to use it either for training a model, or for running
inference, you will need to pre-process the data first. In general, this will involve the following steps:`),Be=h(),$=n("ul"),$e=n("li"),Xt=i("Resampling the audio data"),Gt=h(),ke=n("li"),Jt=i("Filtering the dataset"),Kt=h(),qe=n("li"),Qt=i("Converting audio data to model\u2019s expected input"),Xe=h(),q=n("h2"),D=n("a"),Ee=n("span"),c(Y.$$.fragment),Vt=h(),je=n("span"),Zt=i("Resampling the audio data"),Ge=h(),T=n("p"),ea=i("The "),Pe=n("code"),ta=i("load_dataset"),aa=i(` function downloads audio examples with the sampling rate that they were published with. This is not
always the sampling rate expected by a model you plan to train, or use for inference. If there\u2019s a discrepancy between
the sampling rates, you can resample the audio to the model\u2019s expected sampling rate.`),Je=h(),ie=n("p"),sa=i(`Most of the available pretrained models have been pretrained on audio datasets at a sampling rate of 16 kHz.
When we explored MINDS-14 dataset, you may have noticed that it is sampled at 8 kHz, which means we will likely need
to upsample it.`),Ke=h(),I=n("p"),oa=i("To do so, use \u{1F917} Datasets\u2019 "),Ae=n("code"),na=i("cast_column"),ra=i(` method. This operation does not change the audio in-place, but rather signals
to datasets to resample the audio examples on the fly when they are loaded. The following code will set the sampling
rate to 16kHz:`),Qe=h(),c(B.$$.fragment),Ve=h(),N=n("p"),ia=i("Re-load the first audio example in the MINDS-14 dataset, and check that it has been resampled to the desired "),De=n("code"),la=i("sampling rate"),pa=i(":"),Ze=h(),c(X.$$.fragment),et=h(),le=n("p"),ha=i(`You may notice that the array values are now also different. This is because we\u2019ve now got twice the number of amplitude values for
every one that we had before.`),tt=h(),c(S.$$.fragment),at=h(),E=n("h2"),W=n("a"),Te=n("span"),c(G.$$.fragment),ua=h(),Ie=n("span"),da=i("Filtering the dataset"),st=h(),pe=n("p"),fa=i(`You may need to filter the data based on some criteria. One of the common cases involves limiting the audio examples to a
certain duration. For instance, we might want to filter out any examples longer than 20s to prevent out-of-memory errors
when training a model.`),ot=h(),m=n("p"),ma=i("We can do this by using the  \u{1F917} Datasets\u2019 "),Ne=n("code"),ca=i("filter"),ga=i(` method and passing a function with filtering logic to it. Let\u2019s start by writing a
function that indicates which examples to keep and which to discard. This function, `),Se=n("code"),wa=i("is_audio_length_in_range"),_a=i(`,
returns `),We=n("code"),ya=i("True"),va=i(" if a sample is shorter than 20s, and "),Oe=n("code"),ba=i("False"),xa=i(" if it is longer than 20s."),nt=h(),c(J.$$.fragment),rt=h(),he=n("p"),$a=i(`The filtering function can be applied to a dataset\u2019s column but we do not have a column with audio track duration in this
dataset. However, we can create one, filter based on the values in that column, and then remove it.`),it=h(),c(K.$$.fragment),lt=h(),ue=n("p"),ka=i("We can verify that dataset has been filtered down from 654 examples to 624."),pt=h(),j=n("h2"),O=n("a"),Le=n("span"),c(Q.$$.fragment),qa=h(),ze=n("span"),Ea=i("Pre-processing audio data"),ht=h(),de=n("p"),ja=i(`One of the most challenging aspects of working with audio datasets is preparing the data in the right format for model
training. As you saw, the raw audio data comes as an array of sample values. However, pre-trained models, whether you use them
for inference, or want to fine-tune them for your task, expect the raw data to be converted into input features. The
requirements for the input features may vary from one model to another \u2014 they depend on the model\u2019s architecture, and the data it was
pre-trained with. The good news is, for every supported audio model, \u{1F917} Transformers offer a feature extractor class
that can convert raw audio data into the input features the model expects.`),ut=h(),L=n("p"),Pa=i("So what does a feature extractor do with the raw audio data? Let\u2019s take a look at "),V=n("a"),Aa=i("Whisper"),Da=i(`\u2019s
feature extractor to understand some common feature extraction transformations. Whisper is a pre-trained model for
automatic speech recognition (ASR) published in September 2022 by Alec Radford et al. from OpenAI.`),dt=h(),fe=n("p"),Ta=i(`First, the Whisper feature extractor pads/truncates a batch of audio examples such that all
examples have an input length of 30s. Examples shorter than this are padded to 30s by appending zeros to the end of the
sequence (zeros in an audio signal correspond to no signal or silence). Examples longer than 30s are truncated to 30s.
Since all elements in the batch are padded/truncated to a maximum length in the input space, there is no need for an attention
mask. Whisper is unique in this regard, most other audio models require an attention mask that details
where sequences have been padded, and thus where they should be ignored in the self-attention mechanism. Whisper is
trained to operate without an attention mask and infer directly from the speech signals where to ignore the inputs.`),ft=h(),me=n("p"),Ia=i(`The second operation that the Whisper feature extractor performs is converting the padded audio arrays to log-mel spectrograms.
As you recall, these spectrograms describe how the frequencies of a signal change over time, expressed on the mel scale
and measured in decibels (the log part) to make the frequencies and amplitudes more representative of human hearing.`),mt=h(),ce=n("p"),Na=i(`All these transformations can be applied to your raw audio data with a couple of lines of code. Let\u2019s go ahead and load
the feature extractor from the pre-trained Whisper checkpoint to have ready for our audio data:`),ct=h(),c(Z.$$.fragment),gt=h(),z=n("p"),Sa=i("Next, you can write a function to pre-process a single audio example by passing it through the "),Ce=n("code"),Wa=i("feature_extractor"),Oa=i("."),wt=h(),c(ee.$$.fragment),_t=h(),ge=n("p"),La=i("We can apply the data preparation function to all of our training examples using \u{1F917} Datasets\u2019 map method:"),yt=h(),c(te.$$.fragment),vt=h(),C=n("p"),za=i("As easy as that, we now have log-mel spectrograms as "),He=n("code"),Ca=i("input_features"),Ha=i(" in the dataset."),bt=h(),H=n("p"),Fa=i("Let\u2019s visualize it for one of the examples in the "),Fe=n("code"),Ra=i("minds"),Ma=i(" dataset:"),xt=h(),c(ae.$$.fragment),$t=h(),we=n("p"),_e=n("img"),kt=h(),ye=n("p"),Ua=i("Now you can see what the audio input to the Whisper model looks like after preprocessing."),qt=h(),F=n("p"),Ya=i(`The model\u2019s feature extractor class takes care of transforming raw audio data to the format that the model expects. However,
many tasks involving audio are multimodal, e.g. speech recognition. In such cases \u{1F917} Transformers also offer model-specific
tokenizers to process the text inputs. For a deep dive into tokenizers, please refer to our `),se=n("a"),Ba=i("NLP course"),Xa=i("."),Et=h(),R=n("p"),Ga=i(`You can load the feature extractor and tokenizer for Whisper and other multimodal models separately, or you can load both via
a so-called processor. To make things even simpler, use `),Re=n("code"),Ja=i("AutoProcessor"),Ka=i(` to load a model\u2019s feature extractor and processor from a
checkpoint, like this:`),jt=h(),c(oe.$$.fragment),Pt=h(),M=n("p"),Qa=i(`Here we have illustrated the fundamental data preparation steps. Of course, custom data may require more complex preprocessing.
In this case, you can extend the function `),Me=n("code"),Va=i("prepare_dataset"),Za=i(` to perform any sort of custom data transformations. With \u{1F917} Datasets,
if you can write it as a Python function, you can apply it to your dataset!`),this.h()},l(e){const s=Bs('[data-svelte="svelte-1phssyn"]',document.head);f=r(s,"META",{name:!0,content:!0}),s.forEach(t),x=u(e),b=r(e,"H1",{class:!0});var ne=p(b);A=r(ne,"A",{id:!0,class:!0,href:!0});var ts=p(A);be=r(ts,"SPAN",{});var as=p(be);g(U.$$.fragment,as),as.forEach(t),ts.forEach(t),Ut=u(ne),xe=r(ne,"SPAN",{});var ss=p(xe);Yt=l(ss,"Preprocessing an audio dataset"),ss.forEach(t),ne.forEach(t),Ye=u(e),re=r(e,"P",{});var os=p(re);Bt=l(os,`Loading a dataset with \u{1F917} Datasets is just half of the fun. If you plan to use it either for training a model, or for running
inference, you will need to pre-process the data first. In general, this will involve the following steps:`),os.forEach(t),Be=u(e),$=r(e,"UL",{});var ve=p($);$e=r(ve,"LI",{});var ns=p($e);Xt=l(ns,"Resampling the audio data"),ns.forEach(t),Gt=u(ve),ke=r(ve,"LI",{});var rs=p(ke);Jt=l(rs,"Filtering the dataset"),rs.forEach(t),Kt=u(ve),qe=r(ve,"LI",{});var is=p(qe);Qt=l(is,"Converting audio data to model\u2019s expected input"),is.forEach(t),ve.forEach(t),Xe=u(e),q=r(e,"H2",{class:!0});var Dt=p(q);D=r(Dt,"A",{id:!0,class:!0,href:!0});var ls=p(D);Ee=r(ls,"SPAN",{});var ps=p(Ee);g(Y.$$.fragment,ps),ps.forEach(t),ls.forEach(t),Vt=u(Dt),je=r(Dt,"SPAN",{});var hs=p(je);Zt=l(hs,"Resampling the audio data"),hs.forEach(t),Dt.forEach(t),Ge=u(e),T=r(e,"P",{});var Tt=p(T);ea=l(Tt,"The "),Pe=r(Tt,"CODE",{});var us=p(Pe);ta=l(us,"load_dataset"),us.forEach(t),aa=l(Tt,` function downloads audio examples with the sampling rate that they were published with. This is not
always the sampling rate expected by a model you plan to train, or use for inference. If there\u2019s a discrepancy between
the sampling rates, you can resample the audio to the model\u2019s expected sampling rate.`),Tt.forEach(t),Je=u(e),ie=r(e,"P",{});var ds=p(ie);sa=l(ds,`Most of the available pretrained models have been pretrained on audio datasets at a sampling rate of 16 kHz.
When we explored MINDS-14 dataset, you may have noticed that it is sampled at 8 kHz, which means we will likely need
to upsample it.`),ds.forEach(t),Ke=u(e),I=r(e,"P",{});var It=p(I);oa=l(It,"To do so, use \u{1F917} Datasets\u2019 "),Ae=r(It,"CODE",{});var fs=p(Ae);na=l(fs,"cast_column"),fs.forEach(t),ra=l(It,` method. This operation does not change the audio in-place, but rather signals
to datasets to resample the audio examples on the fly when they are loaded. The following code will set the sampling
rate to 16kHz:`),It.forEach(t),Qe=u(e),g(B.$$.fragment,e),Ve=u(e),N=r(e,"P",{});var Nt=p(N);ia=l(Nt,"Re-load the first audio example in the MINDS-14 dataset, and check that it has been resampled to the desired "),De=r(Nt,"CODE",{});var ms=p(De);la=l(ms,"sampling rate"),ms.forEach(t),pa=l(Nt,":"),Nt.forEach(t),Ze=u(e),g(X.$$.fragment,e),et=u(e),le=r(e,"P",{});var cs=p(le);ha=l(cs,`You may notice that the array values are now also different. This is because we\u2019ve now got twice the number of amplitude values for
every one that we had before.`),cs.forEach(t),tt=u(e),g(S.$$.fragment,e),at=u(e),E=r(e,"H2",{class:!0});var St=p(E);W=r(St,"A",{id:!0,class:!0,href:!0});var gs=p(W);Te=r(gs,"SPAN",{});var ws=p(Te);g(G.$$.fragment,ws),ws.forEach(t),gs.forEach(t),ua=u(St),Ie=r(St,"SPAN",{});var _s=p(Ie);da=l(_s,"Filtering the dataset"),_s.forEach(t),St.forEach(t),st=u(e),pe=r(e,"P",{});var ys=p(pe);fa=l(ys,`You may need to filter the data based on some criteria. One of the common cases involves limiting the audio examples to a
certain duration. For instance, we might want to filter out any examples longer than 20s to prevent out-of-memory errors
when training a model.`),ys.forEach(t),ot=u(e),m=r(e,"P",{});var k=p(m);ma=l(k,"We can do this by using the  \u{1F917} Datasets\u2019 "),Ne=r(k,"CODE",{});var vs=p(Ne);ca=l(vs,"filter"),vs.forEach(t),ga=l(k,` method and passing a function with filtering logic to it. Let\u2019s start by writing a
function that indicates which examples to keep and which to discard. This function, `),Se=r(k,"CODE",{});var bs=p(Se);wa=l(bs,"is_audio_length_in_range"),bs.forEach(t),_a=l(k,`,
returns `),We=r(k,"CODE",{});var xs=p(We);ya=l(xs,"True"),xs.forEach(t),va=l(k," if a sample is shorter than 20s, and "),Oe=r(k,"CODE",{});var $s=p(Oe);ba=l($s,"False"),$s.forEach(t),xa=l(k," if it is longer than 20s."),k.forEach(t),nt=u(e),g(J.$$.fragment,e),rt=u(e),he=r(e,"P",{});var ks=p(he);$a=l(ks,`The filtering function can be applied to a dataset\u2019s column but we do not have a column with audio track duration in this
dataset. However, we can create one, filter based on the values in that column, and then remove it.`),ks.forEach(t),it=u(e),g(K.$$.fragment,e),lt=u(e),ue=r(e,"P",{});var qs=p(ue);ka=l(qs,"We can verify that dataset has been filtered down from 654 examples to 624."),qs.forEach(t),pt=u(e),j=r(e,"H2",{class:!0});var Wt=p(j);O=r(Wt,"A",{id:!0,class:!0,href:!0});var Es=p(O);Le=r(Es,"SPAN",{});var js=p(Le);g(Q.$$.fragment,js),js.forEach(t),Es.forEach(t),qa=u(Wt),ze=r(Wt,"SPAN",{});var Ps=p(ze);Ea=l(Ps,"Pre-processing audio data"),Ps.forEach(t),Wt.forEach(t),ht=u(e),de=r(e,"P",{});var As=p(de);ja=l(As,`One of the most challenging aspects of working with audio datasets is preparing the data in the right format for model
training. As you saw, the raw audio data comes as an array of sample values. However, pre-trained models, whether you use them
for inference, or want to fine-tune them for your task, expect the raw data to be converted into input features. The
requirements for the input features may vary from one model to another \u2014 they depend on the model\u2019s architecture, and the data it was
pre-trained with. The good news is, for every supported audio model, \u{1F917} Transformers offer a feature extractor class
that can convert raw audio data into the input features the model expects.`),As.forEach(t),ut=u(e),L=r(e,"P",{});var Ot=p(L);Pa=l(Ot,"So what does a feature extractor do with the raw audio data? Let\u2019s take a look at "),V=r(Ot,"A",{href:!0,rel:!0});var Ds=p(V);Aa=l(Ds,"Whisper"),Ds.forEach(t),Da=l(Ot,`\u2019s
feature extractor to understand some common feature extraction transformations. Whisper is a pre-trained model for
automatic speech recognition (ASR) published in September 2022 by Alec Radford et al. from OpenAI.`),Ot.forEach(t),dt=u(e),fe=r(e,"P",{});var Ts=p(fe);Ta=l(Ts,`First, the Whisper feature extractor pads/truncates a batch of audio examples such that all
examples have an input length of 30s. Examples shorter than this are padded to 30s by appending zeros to the end of the
sequence (zeros in an audio signal correspond to no signal or silence). Examples longer than 30s are truncated to 30s.
Since all elements in the batch are padded/truncated to a maximum length in the input space, there is no need for an attention
mask. Whisper is unique in this regard, most other audio models require an attention mask that details
where sequences have been padded, and thus where they should be ignored in the self-attention mechanism. Whisper is
trained to operate without an attention mask and infer directly from the speech signals where to ignore the inputs.`),Ts.forEach(t),ft=u(e),me=r(e,"P",{});var Is=p(me);Ia=l(Is,`The second operation that the Whisper feature extractor performs is converting the padded audio arrays to log-mel spectrograms.
As you recall, these spectrograms describe how the frequencies of a signal change over time, expressed on the mel scale
and measured in decibels (the log part) to make the frequencies and amplitudes more representative of human hearing.`),Is.forEach(t),mt=u(e),ce=r(e,"P",{});var Ns=p(ce);Na=l(Ns,`All these transformations can be applied to your raw audio data with a couple of lines of code. Let\u2019s go ahead and load
the feature extractor from the pre-trained Whisper checkpoint to have ready for our audio data:`),Ns.forEach(t),ct=u(e),g(Z.$$.fragment,e),gt=u(e),z=r(e,"P",{});var Lt=p(z);Sa=l(Lt,"Next, you can write a function to pre-process a single audio example by passing it through the "),Ce=r(Lt,"CODE",{});var Ss=p(Ce);Wa=l(Ss,"feature_extractor"),Ss.forEach(t),Oa=l(Lt,"."),Lt.forEach(t),wt=u(e),g(ee.$$.fragment,e),_t=u(e),ge=r(e,"P",{});var Ws=p(ge);La=l(Ws,"We can apply the data preparation function to all of our training examples using \u{1F917} Datasets\u2019 map method:"),Ws.forEach(t),yt=u(e),g(te.$$.fragment,e),vt=u(e),C=r(e,"P",{});var zt=p(C);za=l(zt,"As easy as that, we now have log-mel spectrograms as "),He=r(zt,"CODE",{});var Os=p(He);Ca=l(Os,"input_features"),Os.forEach(t),Ha=l(zt," in the dataset."),zt.forEach(t),bt=u(e),H=r(e,"P",{});var Ct=p(H);Fa=l(Ct,"Let\u2019s visualize it for one of the examples in the "),Fe=r(Ct,"CODE",{});var Ls=p(Fe);Ra=l(Ls,"minds"),Ls.forEach(t),Ma=l(Ct," dataset:"),Ct.forEach(t),xt=u(e),g(ae.$$.fragment,e),$t=u(e),we=r(e,"P",{});var zs=p(we);_e=r(zs,"IMG",{src:!0,alt:!0}),zs.forEach(t),kt=u(e),ye=r(e,"P",{});var Cs=p(ye);Ua=l(Cs,"Now you can see what the audio input to the Whisper model looks like after preprocessing."),Cs.forEach(t),qt=u(e),F=r(e,"P",{});var Ht=p(F);Ya=l(Ht,`The model\u2019s feature extractor class takes care of transforming raw audio data to the format that the model expects. However,
many tasks involving audio are multimodal, e.g. speech recognition. In such cases \u{1F917} Transformers also offer model-specific
tokenizers to process the text inputs. For a deep dive into tokenizers, please refer to our `),se=r(Ht,"A",{href:!0,rel:!0});var Hs=p(se);Ba=l(Hs,"NLP course"),Hs.forEach(t),Xa=l(Ht,"."),Ht.forEach(t),Et=u(e),R=r(e,"P",{});var Ft=p(R);Ga=l(Ft,`You can load the feature extractor and tokenizer for Whisper and other multimodal models separately, or you can load both via
a so-called processor. To make things even simpler, use `),Re=r(Ft,"CODE",{});var Fs=p(Re);Ja=l(Fs,"AutoProcessor"),Fs.forEach(t),Ka=l(Ft,` to load a model\u2019s feature extractor and processor from a
checkpoint, like this:`),Ft.forEach(t),jt=u(e),g(oe.$$.fragment,e),Pt=u(e),M=r(e,"P",{});var Rt=p(M);Qa=l(Rt,`Here we have illustrated the fundamental data preparation steps. Of course, custom data may require more complex preprocessing.
In this case, you can extend the function `),Me=r(Rt,"CODE",{});var Rs=p(Me);Va=l(Rs,"prepare_dataset"),Rs.forEach(t),Za=l(Rt,` to perform any sort of custom data transformations. With \u{1F917} Datasets,
if you can write it as a Python function, you can apply it to your dataset!`),Rt.forEach(t),this.h()},h(){d(f,"name","hf:doc:metadata"),d(f,"content",JSON.stringify(Vs)),d(A,"id","preprocessing-an-audio-dataset"),d(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(A,"href","#preprocessing-an-audio-dataset"),d(b,"class","relative group"),d(D,"id","resampling-the-audio-data"),d(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(D,"href","#resampling-the-audio-data"),d(q,"class","relative group"),d(W,"id","filtering-the-dataset"),d(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(W,"href","#filtering-the-dataset"),d(E,"class","relative group"),d(O,"id","preprocessing-audio-data"),d(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(O,"href","#preprocessing-audio-data"),d(j,"class","relative group"),d(V,"href","https://cdn.openai.com/papers/whisper.pdf"),d(V,"rel","nofollow"),Xs(_e.src,es="../../../assets/img/log_mel_whisper.png")||d(_e,"src",es),d(_e,"alt","log_mel_whisper.png"),d(se,"href","https://huggingface.co/course/chapter2/4"),d(se,"rel","nofollow")},m(e,s){a(document.head,f),o(e,x,s),o(e,b,s),a(b,A),a(A,be),w(U,be,null),a(b,Ut),a(b,xe),a(xe,Yt),o(e,Ye,s),o(e,re,s),a(re,Bt),o(e,Be,s),o(e,$,s),a($,$e),a($e,Xt),a($,Gt),a($,ke),a(ke,Jt),a($,Kt),a($,qe),a(qe,Qt),o(e,Xe,s),o(e,q,s),a(q,D),a(D,Ee),w(Y,Ee,null),a(q,Vt),a(q,je),a(je,Zt),o(e,Ge,s),o(e,T,s),a(T,ea),a(T,Pe),a(Pe,ta),a(T,aa),o(e,Je,s),o(e,ie,s),a(ie,sa),o(e,Ke,s),o(e,I,s),a(I,oa),a(I,Ae),a(Ae,na),a(I,ra),o(e,Qe,s),w(B,e,s),o(e,Ve,s),o(e,N,s),a(N,ia),a(N,De),a(De,la),a(N,pa),o(e,Ze,s),w(X,e,s),o(e,et,s),o(e,le,s),a(le,ha),o(e,tt,s),w(S,e,s),o(e,at,s),o(e,E,s),a(E,W),a(W,Te),w(G,Te,null),a(E,ua),a(E,Ie),a(Ie,da),o(e,st,s),o(e,pe,s),a(pe,fa),o(e,ot,s),o(e,m,s),a(m,ma),a(m,Ne),a(Ne,ca),a(m,ga),a(m,Se),a(Se,wa),a(m,_a),a(m,We),a(We,ya),a(m,va),a(m,Oe),a(Oe,ba),a(m,xa),o(e,nt,s),w(J,e,s),o(e,rt,s),o(e,he,s),a(he,$a),o(e,it,s),w(K,e,s),o(e,lt,s),o(e,ue,s),a(ue,ka),o(e,pt,s),o(e,j,s),a(j,O),a(O,Le),w(Q,Le,null),a(j,qa),a(j,ze),a(ze,Ea),o(e,ht,s),o(e,de,s),a(de,ja),o(e,ut,s),o(e,L,s),a(L,Pa),a(L,V),a(V,Aa),a(L,Da),o(e,dt,s),o(e,fe,s),a(fe,Ta),o(e,ft,s),o(e,me,s),a(me,Ia),o(e,mt,s),o(e,ce,s),a(ce,Na),o(e,ct,s),w(Z,e,s),o(e,gt,s),o(e,z,s),a(z,Sa),a(z,Ce),a(Ce,Wa),a(z,Oa),o(e,wt,s),w(ee,e,s),o(e,_t,s),o(e,ge,s),a(ge,La),o(e,yt,s),w(te,e,s),o(e,vt,s),o(e,C,s),a(C,za),a(C,He),a(He,Ca),a(C,Ha),o(e,bt,s),o(e,H,s),a(H,Fa),a(H,Fe),a(Fe,Ra),a(H,Ma),o(e,xt,s),w(ae,e,s),o(e,$t,s),o(e,we,s),a(we,_e),o(e,kt,s),o(e,ye,s),a(ye,Ua),o(e,qt,s),o(e,F,s),a(F,Ya),a(F,se),a(se,Ba),a(F,Xa),o(e,Et,s),o(e,R,s),a(R,Ga),a(R,Re),a(Re,Ja),a(R,Ka),o(e,jt,s),w(oe,e,s),o(e,Pt,s),o(e,M,s),a(M,Qa),a(M,Me),a(Me,Va),a(M,Za),At=!0},p(e,[s]){const ne={};s&2&&(ne.$$scope={dirty:s,ctx:e}),S.$set(ne)},i(e){At||(_(U.$$.fragment,e),_(Y.$$.fragment,e),_(B.$$.fragment,e),_(X.$$.fragment,e),_(S.$$.fragment,e),_(G.$$.fragment,e),_(J.$$.fragment,e),_(K.$$.fragment,e),_(Q.$$.fragment,e),_(Z.$$.fragment,e),_(ee.$$.fragment,e),_(te.$$.fragment,e),_(ae.$$.fragment,e),_(oe.$$.fragment,e),At=!0)},o(e){y(U.$$.fragment,e),y(Y.$$.fragment,e),y(B.$$.fragment,e),y(X.$$.fragment,e),y(S.$$.fragment,e),y(G.$$.fragment,e),y(J.$$.fragment,e),y(K.$$.fragment,e),y(Q.$$.fragment,e),y(Z.$$.fragment,e),y(ee.$$.fragment,e),y(te.$$.fragment,e),y(ae.$$.fragment,e),y(oe.$$.fragment,e),At=!1},d(e){t(f),e&&t(x),e&&t(b),v(U),e&&t(Ye),e&&t(re),e&&t(Be),e&&t($),e&&t(Xe),e&&t(q),v(Y),e&&t(Ge),e&&t(T),e&&t(Je),e&&t(ie),e&&t(Ke),e&&t(I),e&&t(Qe),v(B,e),e&&t(Ve),e&&t(N),e&&t(Ze),v(X,e),e&&t(et),e&&t(le),e&&t(tt),v(S,e),e&&t(at),e&&t(E),v(G),e&&t(st),e&&t(pe),e&&t(ot),e&&t(m),e&&t(nt),v(J,e),e&&t(rt),e&&t(he),e&&t(it),v(K,e),e&&t(lt),e&&t(ue),e&&t(pt),e&&t(j),v(Q),e&&t(ht),e&&t(de),e&&t(ut),e&&t(L),e&&t(dt),e&&t(fe),e&&t(ft),e&&t(me),e&&t(mt),e&&t(ce),e&&t(ct),v(Z,e),e&&t(gt),e&&t(z),e&&t(wt),v(ee,e),e&&t(_t),e&&t(ge),e&&t(yt),v(te,e),e&&t(vt),e&&t(C),e&&t(bt),e&&t(H),e&&t(xt),v(ae,e),e&&t($t),e&&t(we),e&&t(kt),e&&t(ye),e&&t(qt),e&&t(F),e&&t(Et),e&&t(R),e&&t(jt),v(oe,e),e&&t(Pt),e&&t(M)}}}const Vs={local:"preprocessing-an-audio-dataset",sections:[{local:"resampling-the-audio-data",title:"Resampling the audio data"},{local:"filtering-the-dataset",title:"Filtering the dataset"},{local:"preprocessing-audio-data",title:"Pre-processing audio data"}],title:"Preprocessing an audio dataset"};function Zs(Ue){return Gs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class oo extends Ms{constructor(f){super();Us(this,f,Zs,Qs,Ys,{})}}export{oo as default,Vs as metadata};
